program BMP2ICO;
{Program preformatuje obrazek formatu BMP na ikonu typu ICO}
uses Dos,Crt;

var
   Jmeno         :string;
   Dir           :DirStr;
   Name          :NameStr;
   Ext           :ExtStr;
   VstupFile     :SearchRec;
   i             :word;
   EndOut        :string[128];


Procedure Make_ico(Filename:PathStr);
{Otevre soubor formatu BMP, zkontroluje typ souboru a rozmer obrazku.
 Potom zkontroluje, zda neexistuje jiz ikona stejneho jmena a pokud ano,
 overi si, zda se ma prepsat. Nakonec vytvori novy soubor formatu ICO.}

Const
   HlavOut=#0#0#1#0#1#0#32#32#16#0#0#0#0#0#$E8#2#0#0#$16#0#0#0#$28#0#0#0#$20#0#0#0#$40#0#0#0#1#0#4#0#0#0#0#0#$80#2#0#0#0#0;

Var
   Soubor,
   Ikona,
   IDir          :DirStr;
   IName         :NameStr;
   IExt          :ExtStr;
   VystupFile    :SearchRec;
   FileOk        :boolean;
   Vstup,
   Vystup        :text;
   Ident         :string[3];
   Dummy1        :string[15];
   Sirka,
   Vyska         :String[4];
   Dummy2        :String[14];
   Bajt          :char;
   Prepsat       :char;

begin;
   FileOk:=true;
   FSplit(Filename,IDir,IName,IExt);
   Soubor:=IDir+Iname+IExt;
   assign(vstup,soubor);
   reset(vstup);
   read(vstup,Ident,Dummy1,Sirka,Vyska,Dummy2);
   if Ident<>'BMv' then begin
      WriteLn('Soubor "'+soubor+'" neni typu "16-color bitmap".');
      close(vstup);
      FileOk:=False;
   end{if} else if (Sirka<>#32#0#0#0) or (Vyska<>#32#0#0#0) then begin
      WriteLn('Soubor '+soubor+' neni obrazek velikosti 32x32 pixlu.');
      close(vstup);
      FileOk:=False;
   end{if};
   If FileOk then begin
      Ikona:=IDir+IName+'.ICO';
      FindFirst(Ikona,$3F,VystupFile);
      if IName+'.ICO'=VystupFile.Name then begin
         write('Soubor '+IName+'.ICO jiz existuje. Prepsat ?(A/N)');
         Prepsat:=readkey;
         writeln(Prepsat);
         if (Prepsat<>'A') and (Prepsat<>'a') then
         FileOk:=False;
      end{if};
   end{if};
   if FileOk then begin
      assign(vystup,ikona);
      rewrite(vystup);
      writeln(Soubor+' => '+IName+'.ICO');
      write(vystup,HlavOut);
      while not eof(vstup) do begin
         read(vstup,bajt);
         write(vystup,bajt);
      end{while};
      write (vystup,EndOut);
      close(Vstup);
      close(Vystup);
  end{if};
end {of Make_Ico};

Procedure Help;
begin;
   Writeln;
   writeln('Obrazek musi mit rozmer 32x32 pixlu a musi byt ulozen jako 16-color bitmap');
   writeln;
   writeln('Syntaxe: BMP2ICO [/? | -? | /h | /H | [filename[.BMP]]');
   Writeln;
   writeln('         kde filname - jmeno souboru s obrazkem,');
   Writeln('                       ktere muze obsahovat wildcards(*,?)');
   Writeln('         /?,-?,-h,-H - vypise tuto napovedu');
   Writeln('Pokud se zadne jmeno nezada, program se na jmeno zepta.');
   Halt(1);
end{Help};


begin
   writeln('BMP2ICO - ver. 1.0, autor Ing. Z. Zima, 1992');
   writeln('Program pro prevod obrazku formatu BMP na ikonu pro WINDOWS');
   if (ParamStr(1)='/?') or (ParamStr(1)='-?') or (ParamStr(1)='-h') or (ParamStr(1)='-H') then Help;
   if ParamCount=0 then begin
      Write('Jmeno souboru s obrazkem : ');
      readln(jmeno);
      i:=Length(jmeno);
      While i>0 do begin
         If jmeno[i]=' ' then Delete(jmeno,i,1);
         i:=i-1;
      end{While};
      If Length(jmeno)=0 then Help;
   end{if} else
   jmeno:=paramstr(1);
   if pos('.',jmeno)=0 then begin
      jmeno:=jmeno+'.BMP';
   end{if};
   if pos('.*',jmeno)<>0 then
      jmeno:=copy(jmeno,1,pos('.',jmeno))+'BMP';
   jmeno:=FExpand(jmeno);
   FSplit(jmeno,Dir,Name,Ext);
   VstupFile.Name:='            ';
   FindFirst(jmeno,$3F,VstupFile);
   if '            '=VstupFile.Name then begin
      writeln('Soubor '+jmeno+' nenalezen.');
      Halt(2);
   end{if};
   i:=1;
   EndOut:='';
   while i<129 do begin
      EndOut:=EndOut+#0;
      i:=i+1;
   end{while};
   Make_Ico(Dir+VstupFile.Name);
   if (pos('*',jmeno)<>0) or (pos('?',jmeno)<>0) then
      repeat
         VstupFile.Name:='            ';
         FindNext(VstupFile);
         if '            '<>VstupFile.Name then Make_Ico(VstupFile.Name);
      until '            '=VstupFile.Name;
   {endif};
end{program}.

