program Celularne_automaty;
uses
  Crt, Dos, Graph;
const
  l_okraj = 0;
  p_okraj = 639;
  rozsah_tabulky = 100;
var
  pocet_stavov, velkost_okolia,
  typ_okolia, typ_pociatku,volba : byte;
  graf_karta, graf_mod           : integer;
  stare_pole,nove_pole: array[l_okraj..p_okraj]  of byte;
  stav_tab            : array[0..rozsah_tabulky] of byte;

procedure Start_grafiky;
begin
  InitGraph(graf_karta,graf_mod,'');
  if GraphResult <> GrOk then begin
    writeln('Chyba pri inicializacii grafiky !');
    Halt(1);
  end;
end;

procedure Nastavene_parametre;
  var
    poradie : integer;
    automat : string[5];
    chyba   : integer;
begin
  automat := '001011';
  pocet_stavov := 2;   typ_pociatku := 1;
  velkost_okolia := 2; typ_okolia := 1;
  for poradie := 1 to Length(automat) do
     Val(automat[poradie],stav_tab[poradie-1],chyba);
end;

procedure Zadanie_parametrov;
  var
    poradie, stav : integer;
begin
  write('Pocet stavov  (2-16):');  readln(pocet_stavov);
  write('Velkost okolia (1-4):'); readln(velkost_okolia);
  writeln('Typ okolia: 1 - s centralnou bunkou');
  writeln('            2 - bez centralnej bunky');
  write('Volba: (1/2) :');  readln(typ_okolia);
  writeln('Zadanie tabulky automatu');
  if typ_okolia = 1 then
    stav := (pocet_stavov-1)*(2*velkost_okolia+1)
  else stav := (pocet_stavov-1)*2*velkost_okolia;
  for poradie :=0 to stav do begin
    write('suma buniek: ',poradie,'  stav:');
    readln(stav_tab[poradie]);
  end;
end;


procedure Nahodny_automat;
  var
    poradie, stav : integer;
begin
  if typ_okolia = 1 then
    stav := (pocet_stavov-1)*(2*velkost_okolia+1)
  else stav := (pocet_stavov-1)*2*velkost_okolia;
  for poradie := 0 to stav do
    stav_tab[poradie] := random(pocet_stavov);
end;

procedure Vypis_automatu;
  var
    poradie, stav : integer;
begin
  if typ_okolia = 1 then
    stav := (pocet_stavov-1)*(2*velkost_okolia+1)
  else stav := (pocet_stavov-1)*2*velkost_okolia;
  writeln('Pocet stavov: ',pocet_stavov);
  writeln('Velkost okolia: ',velkost_okolia);
  for poradie := 0 to stav do
    writeln('suma buniek: ',poradie,'  stav:',
           stav_tab[poradie]);
  repeat until KeyPressed;
end;

procedure Pole_nahodnych_buniek;
  var
    poloha : integer;
begin
  for poloha := l_okraj to p_okraj do begin
    stare_pole[poloha] := random(pocet_stavov);
    nove_pole[poloha] := 0
  end;
end;

procedure Pociatocny_stav_pola;
  var
    poradie, dlzka,
    od_stlpca, po_stlpec, chyba : integer;
    postupnost : string;
begin
  for poradie := l_okraj to p_okraj do begin
    nove_pole[poradie] := 0;
    stare_pole[poradie] := 0;
  end;
  writeln('Zadajte postupnost:'); read(postupnost);
  dlzka := Length(postupnost);
  od_stlpca := (640-dlzka) div 2;
  po_stlpec := od_stlpca+dlzka;
  for poradie:=1 to dlzka do
    Val(postupnost[poradie],
        stare_pole[od_stlpca+poradie],chyba);
end;

procedure Volba_pociatku;
begin
  ClrScr;  writeln('1 - nahodny pociatok');
  writeln('2 - zadanie pociatku');
  write('Vasa volba:');  readln(typ_pociatku);
end;

procedure Evolucia_buniek;
  var
    poradie, rozsah, cas, suma, riadok : integer;
begin
  if typ_pociatku = 1 then Pole_nahodnych_buniek
  else Pociatocny_stav_pola;
  Start_grafiky;  cas := 0;  riadok := 0;
  repeat
    for poradie := l_okraj+velkost_okolia to
                 p_okraj-velkost_okolia do begin
      suma := 0;
      for rozsah := poradie-velkost_okolia to
                  poradie+velkost_okolia do
        suma := suma + stare_pole[rozsah];
      if typ_okolia = 2 then
      suma := suma - stare_pole[poradie];
      nove_pole[poradie] := stav_tab[suma];
      PutPixel(poradie,riadok,nove_pole[poradie]);
    end;
    inc(cas);  inc(riadok);
    if riadok > GetMaxY-1 then begin
      ClearViewPort; riadok := 0;
    end;
    for poradie := l_okraj+velkost_okolia to
                 p_okraj-velkost_okolia do begin
      suma := 0;
      for rozsah := poradie-velkost_okolia to
                  poradie+velkost_okolia do
        suma := suma + nove_pole[rozsah];
      if typ_okolia = 2 then
        suma := suma - nove_pole[poradie];
      stare_pole[poradie] := stav_tab[suma];
      PutPixel(poradie,riadok,stare_pole[poradie]);
    end;
    inc(cas);  inc(riadok);
    if riadok > GetMaxY then begin
      ClearViewPort;  riadok := 0;
    end;
  until KeyPressed;
  CloseGraph;
end;

begin
  Nastavene_parametre;
  repeat
    ClrScr; writeln('PONUKA CINNOSTI');
    writeln('1 - Evolucia automatu');
    writeln('2 - Zadanie automatu');
    writeln('3 - Typ pociatku');
    writeln('4 - Nahodny automat');
    writeln('5 - Vypis automatu');
    write('VOLBA: ');  readln(volba);
    case volba of
      1: Evolucia_buniek;
      2: Zadanie_parametrov;
      3: Volba_pociatku;
      4: Nahodny_automat;
      5: Vypis_automatu;
    end;
  until volba > 5;
end.