program DemoOverWindow;

uses Crt,MyWindow;

type  TOkno             = record
                            x1,
                            y1,
                            x2,
                            y2,
                            Atribut : byte;
                            Titul   : string[7];
                            pObsah  : MyWindow.TObsah;
                            pPovod  : MyWindow.TPovod
                          end;

const MAX_OKNO          = 8;
      Sirka     : byte  = 40;
      Vyska     : byte  = 10;
      TextChyby : array[1..4] of TStr60 =
                  ('Bol stlaceny nedovoleny znak',
                   'Najskor musi byt otvorene aspon jedno okno',
                   'Definovane okno nie je otvorene',
                   'Cinnost v okne nie je zatial mozna');

var   Okno      : array[1..MAX_OKNO] of TOkno;
      MaxOkno   : TOkno;

procedure OtvorOkno( var Okno : TOkno );
begin
  with Okno do
  begin
    OdlozPovodneOkno(pPovod);
    Window(x1,y1,x2,y2);
    OdlozObsahOkna(pObsah);
    TextAttr:=Atribut;
    ClrScr;
    OramujOkno;
    VypisTitulOkna(Titul)
  end
end;

procedure ZatvorOkno( var Okno : TOkno );
begin
  with Okno do
  begin
    VratObsahOkna(pObsah);
    VratPovodneOkno(pPovod)
  end
end;

procedure Posun( var PoradieOkna : byte );
begin
  ZatvorOkno(Okno[PoradieOkna]);
  OtvorOkno(Okno[PoradieOkna])
end;

function Chyba( Podmienka : boolean; IndexTextu : byte ): boolean;
begin
  if not Podmienka then
    VypisChybovyOznam(TextChyby[IndexTextu]);
  Chyba:=not Podmienka
end;

procedure Hore( var PoradieOkna : byte );
begin
  if not Chyba(PoradieOkna <> 0,2) then
    with Okno[PoradieOkna] do
    begin
      if y1 > 2 then
      begin
        Dec(y1);
        Dec(y2);
        if y2-y1+1 <> Vyska then
          Inc(y2);
        Posun(PoradieOkna)
      end
    end
end;

procedure Dole( var PoradieOkna : byte );
begin
  if not Chyba(PoradieOkna <> 0,2) then
    with Okno[PoradieOkna] do
    begin
      if y1+2 < DISPLAY_ROW then
      begin
        Inc(y1);
        Inc(y2);
        if y2 > DISPLAY_ROW then
          y2:=DISPLAY_ROW;
        Posun(PoradieOkna)
      end
    end
end;

procedure Vpravo( var PoradieOkna : byte );
begin
  if not Chyba(PoradieOkna <> 0,2) then
    with Okno[PoradieOkna] do
    begin
      if x2 < DISPLAY_COL-1 then
      begin
        Inc(x2);
        Inc(x1);
        Posun(PoradieOkna)
      end
    end
end;

procedure Vlavo( var PoradieOkna : byte );
begin
  if not Chyba(PoradieOkna <> 0,2) then
    with Okno[PoradieOkna] do
    begin
      if x1 > 2 then
      begin
        Dec(x1);
        Dec(x2);
        Posun(PoradieOkna)
      end
    end
end;

procedure InitWindow;
var i : byte;

begin
  for i:=1 to MAX_OKNO do
    with Okno[i] do
    begin
      pObsah:=NIL;
      pPovod:=NIL;
      x1:=i+1;
      y1:=i+1;
      x2:=x1+Sirka-1;
      y2:=y1+Vyska-1;
      Atribut:=Yellow+(i-1)*16;
      Titul:=MyWindow.StrLongInt(i)+'. okno'
    end;
  with MaxOkno do
  begin
    x1:=1;
    y1:=1;
    x2:=DISPLAY_COL;
    y2:=DISPLAY_ROW;
    pObsah:=NIL;
    pPovod:=NIL
  end
end;

procedure VypisInfo( PoradieOkna : byte );
const Info0   = '<PgUp>  <Esc>Koniec';
      Info1   = '<PgUp>  <PgDn>  <Alt>^CisloOkna  '#27#25#24#26;
      Info8   = '<PgDn>  <Alt>^CisloOkna  '#27#25#24#26;
      InfoM   = '<Esc>';

var   InfoStr : TStr60;

begin
  case PoradieOkna of
    0             : InfoStr:=Info0;
    1..MAX_OKNO-1 : InfoStr:=Info1;
    MAX_OKNO      : InfoStr:=Info8
    else
      InfoStr:=InfoM
  end;     { case }
  VideoText(1,DISPLAY_COL,DISPLAY_ROW+1,
    CenterText(InfoStr,DISPLAY_COL,
      MEDZERA),MEDZERA,AttrInfo[COLOR])
end;

procedure Zoom( PoradieOkna, IndexOkna : byte );
begin
  if not Chyba(IndexOkna <= PoradieOkna,3) then
    with MaxOkno do
    begin
      Titul:=Okno[IndexOkna].Titul;
      Atribut:=Okno[IndexOkna].Atribut;
      OtvorOkno(MaxOkno);
      Chyba(FALSE,4);
      ZatvorOkno(MaxOkno)
    end
end;

procedure ZmenaPoradia( var PoradieOkna : byte;
                            Diferencia  : integer );
begin
  if Diferencia = -1 then
  begin
    if not Chyba(PoradieOkna > 0,1) then
    begin
      ZatvorOkno(Okno[PoradieOkna]);
      Dec(PoradieOkna)
    end
  end
  else
    if Diferencia = 1 then
      if not Chyba(PoradieOkna < MAX_OKNO,1) then
      begin
        Inc(PoradieOkna);
        OtvorOkno(Okno[PoradieOkna])
      end;
  VypisInfo(PoradieOkna)
end;

procedure RiadiaciProces;
const PoradieOkna : byte = 0;

var   Znak        : char;
      Koniec      : boolean;

begin
  VypisInfo(PoradieOkna);
  Koniec:=FALSE;
  repeat
    Znak:=ReadKey;
    case Znak of
      #0  : begin
              Znak:=ReadKey;
              case Znak of
                #72        : Hore(PoradieOkna);
                #73        : ZmenaPoradia(PoradieOkna,1);
                #75        : Vlavo(PoradieOkna);
                #77        : Vpravo(PoradieOkna);
                #80        : Dole(PoradieOkna);
                #81        : ZmenaPoradia(PoradieOkna,-1);
                #120..#127 : Zoom(PoradieOkna,byte(Znak)-119)
                else
                  Chyba(FALSE,1)
              end            { case }
            end;
      #27 : begin
              Koniec:=PoradieOkna = 0;
              Chyba(Koniec,1)
            end
      else
        Chyba(FALSE,1)
    end     { case }
  until Koniec
end;

begin
  ZakladneOkno;
  InitWindow;
  RiadiaciProces
end.
