Program Edit_Sek;
 {Program pro editaci libovolnho sektoru na disket.  Ka-}
 {d  byte  sektoru  lze  pepsat  libovolnm  znakem ASCII}
 {tabulky,   vyjma  znaku  <ESC>=#27.   Znak  <ESC>  slou}
 {k ukonen editace.  Znak s  ordinaln hodnotou vt ne}
 {126  lze  zadat  souasnm  stiskem  klvesy <ALT> a jeho}
 {ordinln hodnotou na numerick klvesnici.              }
 {---------------------------------------------------------}
 {     Autor:  Vt Maleek; Lidick 33; 795 01 Rmaov     }
 {---------------------------------------------------------}

 uses
  Crt, Dos;
 const
  LengthSect     = 512;   {Poet byt v sektoru, stand. 512}
  Modif: Boolean = False;
 var
  Reg: Registers;
  HdG, FtG, SecG: Byte;     {Specifikace sektoru na disket}
  Sect:Array [1..512] of Byte;     {Buffer pro jeden sektor}

 Function Quest(TextStr: String): Char;
  { Vype dotaz na obrazovku a vrac "stisknutou klvesu" }
  const
   Null=#0;
  var
   CharElect: Char;
  begin
   GotoXY(1,24);
   Write(TextStr,'.',#8);
   CharElect:=Readkey;
   If (CharElect=Null) and KeyPressed then begin
    CharElect:=ReadKey;
    CharElect:=Chr(ord(CharElect)+128);
   end;
   Write(CharElect);
   Quest:=CharElect;
  end; {Quest}

 Procedure ReadSect(Hd, Ft, Sc: byte);
  { Pete sektor "Sc" z diskety v mechanice "A:" }
  { zapsan na stop "Ft" a na povrchu "Hd"       }
  var I: 1..LengthSect;   Rep: Char;
  begin
   FillChar(Sect,SizeOf(Sect),#254);
   With Reg do begin
    repeat
     AH:=2;             { slo podfunkce }
     AL:=1;             { Kolik sektor }
     CH:=Ft;            { Stopa  }
     CL:=Sc;            { Sektor }
     DH:=Hd;            { Povrch }
     DL:=0;             { Identifikace jednotky [0=A, 1=B] }
     ES:=seg(Sect);     { Adresa bufferu pro ulozeni sekt. }
     BX:=ofs(Sect[1]);
     Intr($13,Reg);
     If AH <> 0 then
      If not (Quest('Chyba pri cteni. Znovu? [A/N]: ')
      in ['A','a']) then Exit;
    until AH = 0;       { Bezchybna operace }
   end; {with}
  end; {ReadSect}

 Procedure ShowSect;
  {  Zobraz peten sektor na obrazovku ve vhodn form  }
  var
   I: 1..18;                        { 18 dk   ve vpisu }
   J: 1..30;                        { 30 sloupc ve vpisu }
   CtrlCh: Char;
  begin
   ClrScr;                        { Zobraz hlaviku vpisu }
   Write('                                ');
   Writeln('                             ');
   Write('    ');
   For J:=1 to 30 do Write((J mod 10):2);
   Writeln;
   For I:=1 to 18  do begin {Zobraz sektor do tabulky 18x30}
    Write((I*30)-30:3,' ');
    For J:=1 to 30 do begin
     If (I<=17) or ((I=18) and (J<3)) then begin
      If not(Chr(Sect[30*(I-1)+J]) in [#7,#8,#10,#13,#27])
      then Write(Chr(Sect[30*(I-1)+J]):2);
      If Sect[30*(I-1)+J] in [7,8,10,13,27] then begin
        case Sect[30*(I-1)+J] of
           7: CtrlCh:='G';   { <BackSpace> }
           8: CtrlCh:='H';   { <Bell>      }
          10: CtrlCh:='J';   { <LF>        }
          13: CtrlCh:='M';   { <CR>        }
        end; {case}
       Write('^',CtrlCh);
      end; {If Sect[30}
     end; {If (I<=17}
    end; {For J}
    Writeln;
   end; {For I}
   Writeln;
  end; {ShowSect}

 Procedure EditSect;
  { Procedura pro vlastn editaci sektoru }
  const
   Right=#205; Left=#203; Down=#208; Up=#200; Null=#0;
  var
   XEdt, YEdt: Byte;                  { Souadnice kurzoru }
   CtrlCh, Ch: Char;

   Function WaitToPress: Char;
    { Oekv stisk klvesy a vrac jej kd }
    var
     Key: Char;
    begin
     repeat
     until Keypressed;
     Key:=Readkey;
     If (Key=Null) and KeyPressed then
     begin
      Key:=ReadKey;
      Key:=Chr(ord(Key)+128);
     end;
     WaitToPress:=Key;
    end; {WaitToPress}

  begin {EditSect}
   GotoXY(6,3);
   repeat
    Ch:=WaitToPress;
    If Ch<>#27 then begin
     Modif:=True;
     If Ch in [Left,Right,Up,Down] then
      Case Ch of
       Left:  If WhereX>6  then GotoXY(WhereX-2,WhereY);
       Right: If WhereX<64 then GotoXY(WhereX+2,WhereY);
       Up:    If WhereY>3  then GotoXY(WhereX,WhereY-1);
       Down:  If WhereY<20 then GotoXY(WhereX,WhereY+1);
      end {case}
     else begin
      XEdt:=WhereX; YEdt:=WhereY;
      Sect[(YEdt-3)*30+(XEdt div 2)-2]:=Ord(Ch);
      If not (Ch in [#7,#8,#10,#13,#27]) then begin
       GotoXY(XEdt-1,YEdt);
       Write(' ',Ch);
       GotoXY(XEdt,YEdt);
      end; {If not Ch}
      If Ch in [#7,#8,#10,#13,#27] then begin
       GotoXY(XEdt-1,YEdt);
       case Ch of
         #7: CtrlCh:='G';   { <BackSpace> }
         #8: CtrlCh:='H';   { <Bell>      }
        #10: CtrlCh:='J';   { <LF>        }
        #13: CtrlCh:='M';   { <CR>        }
       end; {case}
       Write('^',CtrlCh);
       GotoXY(XEdt,YEdt);
      end; {If Ch}
     end; {else}
    end; {If Ch<>27}
   until Ch=#27;
  end; {EditSect}

 Procedure WriteSect(Hd, Ft, Sc: byte);
  { Zape sektor "Sc" na disketu v mechanice "A:" }
  { a to na stopu "Ft" a na povrch "Hd".           }
  var
   I: 1..LengthSect;
   Rep: Char;
  begin
   With Reg do begin
    repeat
     AH:=3;       { slo podfunkce }
     AL:=1;       { Kolik sektor }
     CH:=Ft;      { Stopa  }
     CL:=Sc;      { Sektor }
     DH:=Hd;      { Povrch }
     DL:=0;       { Identifikace jednotky A: }
     ES:=seg(Sect);
     BX:=ofs(Sect[1]);
     Intr($13,Reg);
      If AH <> 0 then
      If not (Quest('Chyba pri zapisu. Opakovat? [A/N]: ')
      in ['A','a']) then Exit;
    until AH = 0;
   end; {with}
  end; {WriteSect}

 Procedure SectToEdit;
  { Dotaz na sektor k editaci }
  begin
   ClrScr;
   Write('Povrch [0..1] : ');
   Readln(HdG);
   Write('Stopa  [0..39]: ');
   Readln(FtG);
   Write('Sektor [1..9] : ');
   Readln(SecG);
  end; {SectToEdit}

 begin {MAIN}
  repeat
   SectToEdit;
   ReadSect(HdG, FtG, SecG);
   ShowSect;
   EditSect;
   ShowSect;
   If Modif then If Quest('Zapsat zmeny? [A/N] : ') in ['A','a'] then
    WriteSect(HdG, FtG, SecG);
  until not (Quest('Dalsi sektor? [A/N] : ') in ['A','a']);
 end.
