name      Hard_Cleaner_File
; ***************************************************
; *   H a r d   C l e a n e r   F i l e   V 2 . 0   *
; *                                                 *
; *        Autor : Marcel PALKO & 3/S Corp.         *
; *                Copyright (c) 1993               *
; *                Zilina , SLOVAKIA                *
; ***************************************************
;
          .model  small
          .stack  40h
          .data
Vram      dw    0
Mode      db    0
Col       db    0
Adr       dw    0
Handle    dw    0
NBlocks   dw    0
NBytes    dw    0
Block     dw    0
BlockX    db    512     dup(0)
NL        db    0dh,0ah,24h

Mess1     db    'Incorrect DOS version !',07h,0dh,0ah,24h
Mess2     db    'File not found !',07h,0dh,0ah,24h
Mess3     db    'Attribute of file is READ-ONLY !',07h,0dh,0ah,24h
Mess4     db    'Error in filename !',07h,0dh,0ah,24h
Mess5     db    'Disk drive is not ready !',07h,0dh,0ah,24h
Mess6     db    'Write protect error !',07h,0dh,0ah,24h
Mess7     db    'Wait please ...',20h,24h
Mess8     db    0dh,0ah,'OK !',07h,0dh,0ah,24h

Mess      LABEL WORD
          dw    offset Mess1
          dw    offset Mess2
          dw    offset Mess3
          dw    offset Mess4
          dw    offset Mess5
          dw    offset Mess6
          dw    offset Mess7
          dw    offset Mess8

HelpT     LABEL BYTE            ; Help Text
          db    'Hard Cleaner File Version 2.0  Copyright (c)',20h
          db    '1993  M.Palko & 3/S Corp.,Slovakia',0dh,0ah
          db    'Program HCF (Hard Cleaner File) fyzicky odstranuje'
          db    20h,'subor z disku (HD) alebo dis-kety (FD). Takto'
          db    20h,'vymazany subor je neobnovitelny !!!',0dh,0ah
          db    'Syntax  : [d:][path]filename.ext',0dh,0ah
          db    'Priklady:  c:\users\abc.txt',0dh,0ah
          db    11      dup(20h)
          db    'a:\myprog\pas\xyz.pas',0dh,0ah
          db    10      dup(20h),0dh,0ah
          db    'Path & FileName : ',24h

PosAnsw   db    'yes'
Question  db    'Are you SURE you want to delete this file ? (yes/n)'
          db    20h,24h

BufferQ   LABEL BYTE
          db    4,0
Answer    db    4       dup(0)

DTA       LABEL BYTE            ; Disk Transfer Address
DDrive    db    1       dup(?)
DName     db    8       dup(?)
Dext      db    3       dup(?)
          db    25      dup(0)  ; vyplni DOS

FName     LABEL BYTE
          db    65,0
FNameX    db    65      dup(0)
          db    0

          .code
LenAnsw   equ   3d
WriteMode equ   1d
ReadTest  equ   02h
WriteTest equ   03h
BasBlock  equ   512d

;-------------------------------------------
; HLAVNY PROGRAM
MainPrg:  mov   ax,@data
          mov   ds,ax
          call  DosTest
          jc    End1
          call  Help
          call  FileName
          jc    End2
          mov   ah,ReadTest
          call  DriveTest
          jc    End1
          call  FindFile
          jc    End1
          call  FileAtt
          jc    End1
          mov   ah,WriteTest
          call  DriveTest
          jc    End1
          call  Security
          jc    End2
          mov   al,07h
          call  Messages
          call  OpenFile
          call  ReWrite
          call  CutFile
          call  CloseFile
          call  DelFile
          mov   al,08h
End1:     call  Messages
End2:     mov   ax,4c00h
          int   21h

;-------------------------------------------
; Procedura DosTest
; zistenie verzie DOSu a ukoncenie s chybo-
; vou spravou, ak je verzia nizsia nez 2.0.
DosTest   proc
          push  bx
          push  cx
          mov   ah,30h
          xor   al,al
          int   21h
          cmp   al,2d
          jnb   DT_ok
DT_err:   stc
          mov   al,01h
DT_end:   pop   cx
          pop   bx
          ret
DT_ok:    clc
          xor   al,al
          jmp   DT_end
DosTest   endp

;-------------------------------------------
; Procedura FileName
; nacitanie cesty a nazvu subora z klaves-
; nice. Ak sa neurci cesta, bude sa pracovat
; v aktualnom adresari.
FileName  proc
          push  dx
          mov   ah,0ah
          mov   dx,offset FName
          int   21h
          mov   ah,09h
          mov   dx,offset NL
          int   21h
          mov   al,FName[1]
          cmp   al,1d
          jne   FN0
          stc
FN0:      pop   dx
          ret
FileName  endp

;-------------------------------------------
; Procedura DriveTest
; testuje sa pripravenost mechaniky na
; - citanie ... AH=02h
; - zapis ..... AH=03h
DriveTest proc
          push  bx
          push  cx
          push  dx
          push  ax
          mov   al,FNameX[1]
          cmp   al,3ah
          jne   D_end1
          mov   dh,FNameX[0]
          and   dh,0dfh
          mov   dl,dh
          sub   dh,43h
          jnc   D_end1
          sub   dl,41h
          mov   ax,seg BlockX
          mov   es,ax
          mov   bx,offset BlockX
          pop   ax
          mov   al,01h
          mov   cl,al
          xor   ch,ch
          mov   dh,00h
          int   13h
          jnc   D_end2
          cmp   ah,03h
          jne   D1
          mov   al,06h
          jmp   D_err
D1:       cmp   ah,80h
          jne   D_end2
          mov   al,05h
D_err:    stc
          jmp   D_end3
D_end1:   pop   ax
D_end2:   clc
D_end3:   pop   dx
          pop   cx
          pop   bx
          ret
DriveTest endp

;-------------------------------------------
; Procedura FindFile
; hlada subor podla zadanej cesty.
FindFile  proc
          push  dx
          mov   di,offset FNameX
          mov   al,FName[1]
          xor   ah,ah
          add   di,ax
          mov   [di],ah
          mov   dx,offset DTA
          mov   ah,1ah
          int   21h
          mov   dx,offset FNameX
          xor   cx,cx
          mov   ah,4eh
          int   21h
          cmp   al,00h
          jne   FF_err
          clc
FF_end:   pop   dx
          ret
FF_err:   stc
          mov   al,02h
          jmp   FF_end
FindFile  endp

;-------------------------------------------
; Procedura FileAtt
; zisti atribut suboru a v pripade atributu
; READ-ONLY nepovoli jeho vymazanie.
FileAtt   proc
          push  cx
          push  dx
          mov   dx,offset FNameX
          xor   al,al
          mov   ah,43h
          int   21h
          clc
          and   cx,01h
          jnz   FA_err
          cmp   ax,03h
          jne   FA_end
          stc
          mov   al,04h
          jmp   FA_end
FA_err:   stc
          mov   al,03h
FA_end:   pop   dx
          pop   cx
          ret
FileAtt   endp

;-------------------------------------------
; Procedura Security
; vyzve uzivatela, aby potvrdil, ze chce
; skutocne vymazat zadany subor.
Security  proc
          push  cx
          mov   ah,09h
          mov   dx,offset Question
          int   21h
          mov   ah,0ah
          mov   dx,offset BufferQ
          int   21h
          mov   ah,09h
          mov   dx,offset NL
          int   21h
          mov   al,BufferQ[1]
          cmp   al,LenAnsw
          jne   Sec_end
          mov   cx,LenAnsw
          mov   si,offset Answer
          mov   di,offset PosAnsw
Sec0:     mov   al,[si]
          or    al,00100000b
          cmp   al,[di]
          jne   Sec_end
          inc   si
          inc   di
          loop  Sec0
Sec1:     clc
          pop   cx
          ret
Sec_end:  stc
          pop   cx
          ret
Security  endp

;-------------------------------------------
; Procedura OpenFile
; otvori zadany subor na zapis.
OpenFile  proc
          push  dx
          mov   dx,offset FNameX
          mov   al,WriteMode
          mov   ah,3dh
          int   21h
          mov   Handle,ax
          pop   dx
          ret
OpenFile  endp

;-------------------------------------------
; Procedura ReWrite
; prepise obsah suboru znakom 02h.
ReWrite   proc
          push  bx
          push  cx
          call  FLength
          mov   bx,Handle
          call  Init
          call  Move
          mov   dx,offset BlockX
          mov   cx,NBlocks
          cmp   cx,0h
          je    RW3
; ulozenie CX*65536 bajtov
RW2:      push  cx
          mov   cx,BasBlock/4
RW1:      call  WrBlock
          loop  RW1
          pop   cx
          loop  RW2
; premazavanie blokmi 512B, 256B, 128B,...
RW3:      mov   dx,BasBlock
          mov   Block,dx
          mov   cx,NBytes
          cmp   cx,0h
          je    RW_end
RW4:      cmp   cx,Block
          jb    Div2
          push  cx
          mov   ah,40h
          mov   bx,Handle
          mov   cx,Block
          mov   dx,offset BlockX
          int   21h
          pop   cx
          sub   cx,Block
          jz    RW_end
          jmp   RW4
Div2:     mov   ax,Block
          xor   dx,dx
          mov   bx,2d
          div   bx
          mov   Block,ax
          jmp   RW4
RW_end:   clc
          pop   cx
          pop   bx
          ret
ReWrite   endp

;-------------------------------------------
; Procedura FLength
; zisti dlzku suboru.
FLength   proc
          push  bx
          push  cx
          push  dx
          mov   bx,Handle
          xor   cx,cx
          xor   dx,dx
          mov   al,02h
          mov   ah,42h
          int   21h
          mov   NBlocks,dx
          mov   NBytes,ax
          pop   dx
          pop   cx
          pop   bx
          ret
FLength   endp

;-------------------------------------------
; Procedura WrBlock
; zapise do suboru jeden BlockX.
WrBlock   proc
          push  cx
          mov   ah,40h
          mov   cx,BasBlock
          int   21h
          pop   cx
          ret
WrBlock   endp

;-------------------------------------------
; Procedura CutFile
; odreze udajovu cast suboru.
CutFile   proc
          push  bx
          push  cx
          call  Move
          mov   bx,Handle
          mov   dx,offset BlockX
          xor   cx,cx
          mov   ah,40h
          int   21h
          pop   cx
          pop   bx
          ret
CutFile   endp

;-------------------------------------------
; Procedura Move
; presunie FilePointer na zaciatok suboru.
Move      proc
          push  cx
          push  dx
          mov   bx,Handle
          xor   cx,cx
          xor   dx,dx
          xor   al,al
          mov   ah,42h
          int   21h
          pop   dx
          pop   cx
          ret
Move      endp
          
;-------------------------------------------
; Procedura CloseFile
; uzavrie prepisany subor.
CloseFile proc
          push  bx
          mov   bx,Handle
          mov   ah,3eh
          int   21h
          pop   bx
          ret
CloseFile endp

;-------------------------------------------
; Procedura DelFile
; vymaze subor.
DelFile   proc
          push  dx
          mov   dx,offset FNameX
          mov   ah,41h
          int   21h
          pop   dx
          ret
DelFile   endp

;-------------------------------------------
; Procedura Init
; pripravi obsah buffera, ktorym sa bude
; premazavat subor.
Init      proc
          push  cx
          mov   cx,BasBlock
          mov   al,2d
          xor   di,di
Init0:    mov   BlockX[di],al
          inc   di
          loop  Init0
          pop   cx
          ret
Init      endp

;-------------------------------------------
; Procedura Messages
; vypis spravy pre uzivatela.
Messages  proc
          push  dx
          push  di
          xor   ah,ah
          sub   al,01h
          add   ax,ax
          mov   di,ax
          mov   dx,Mess[di]
          mov   ah,09h
          int   21h
          clc
          pop   di
          pop   dx
          ret
Messages  endp

;-------------------------------------------
; Procedura Help
; vypise strucny popis programu a syntax
; prikazu.
Help      proc
          push  ax
          push  dx
          push  ds
          mov   dx,offset HelpT
          mov   ah,09h
          int   21h
          pop   ds
          pop   dx
          pop   ax
          ret
Help      endp
          end
