Program Mem_Anal;
 { Analza obsazen  pamti programem Mem_Anal. }
 { Definovan a pouit  funkce lze zabudovat i }
 { do jinch program, ppadn do libov. unitu.}
 {----------------------------------------------}
 { Zdrojov text zdarma nahraji na zaslanou dis-}
 { ketu, zalete-li t znmku v hodnot 5,-Ks.}
 {----------------------------------------------}
 { Vt  Maleek,  Lidick  33,  795 01  Rmaov }
 {==============================================}
 {$M 2048,25000,25000}
 {Alokujte heap > ne je OvrMaxSize v Over_Mem. }
 uses  Overlay, Over_Mem, Crt, Dos;
       {$O Dos}
 const
  PSP = 256;                               {100h}
  Max = 40;          {Horn mez dynamickho pole}

 type
  THeapSize = record {Zznam pro pevod pointeru}
             Lo, Hi: word
            end;
  Rozsah = 1..Max;        {Meze dynamickho pole}
  PMyStr = ^TMyStr;
  TMyStr = String[9];

 var
  PSizeHip: Pointer;
  SizeHeap: LongInt;     {Pom. prom. pro vpoet}
  PMS:      Array [Rozsah] of PMyStr; {Dyn. pole}
  Q:        Integer;      {dc promnn cyklu}
  OK:       Char;

 Function SizeStack: LongInt;
  { Velikost stack segmentu - zasobniku }
  begin
   SizeStack:=Longint((OvrHeapOrg-SSeg) shl 4);
  end; {SizeStack}

 Function SizeData: LongInt;
  { Velikost datovho segmentu }
  begin
   SizeData:=Longint((SSeg-DSeg) shl 4);
  end;

 Function SizeCode: LongInt;
  { Velikost kdovho segmentu }
  begin
   SizeCode:=Longint((DSeg-CSeg) shl 4);
  end; {SizeCode}

 Function FreeStack: LongInt;
  { Velikost neobsazen sti zsobnku }
  begin
   FreeStack:=LongInt(SPtr);
  end; {FreeStack}

 Function OccupyStack: LongInt;
  { Velikost obsazen st zsobnku }
  begin
   OccupyStack:=Longint(((OvrHeapOrg-SSeg) shl 4)
                - SPtr);
  end; {OccupyStack}

 Function SizeHeapTmp: LongInt;
  { Velikost oblasti pamti uren PSizeHeap }
  begin
   SizeHeapTmp:=LongInt(THeapSize(PSizeHip).Hi)
                * 16 + THeapSize(PSizeHip).Lo;
  end; {SizeHeapTmp}

 Function SizeHFree: LongInt;
  {Oblast mezi vrcholem heapu a posl. al. bytem}
  begin
   PSizeHip:=HeapEnd-HeapPtr;
   SizeHFree:=SizeHeapTmp;
  end; {SizeHFree}

 Function SizeHOccupy: LongInt;
  { Oblast mezi dnem heapu a posled. al. bytem }
  begin
   PSizeHip:=HeapPtr-HeapOrg;
   SizeHOccupy:=SizeHeapTmp;
  end; {SizeHOccupy}

 Function HeapAll: LongInt;
  { Celkov velikost heapu (bez overlay) }
  begin
   PSizeHip:=HeapEnd-HeapOrg;
   HeapAll:=SizeHeapTmp;
  end; {HeapAll}

 Function SizeOverl: LongInt;
  { Velikost oblasti vyhrazen pro pekryvy }
  begin
   SizeOverl:=LongInt((OvrHeapEnd-OvrHeapOrg)
              shl 4);
  end; {SizeOverl}

 Function SizeProg: LongInt;
  { Program okupuje celkem SizeProg byt }
  begin
   SizeProg:=PSP + SizeCode + SizeData +
             SizeStack + HeapAll + SizeOverl;
  end; {SizeProg}

 Function Free_Mem: LongInt;
  { Voln - dosud programy neobsazen pamt }
  var
   FrMem: LongInt;
   R:     Registers;
  begin
   R.AH:=72;                       {Pidl pamt}
   R.BX:=$FFFF;         {Velikost FFFFh pragraf}
   MsDos(R);                           {Intr 21h}
   FrMem:=R.BX;      {Skuten pidleno paragr.}
   FrMem:=FrMem * 16;   {Skuten pidleno byt}
   Free_Mem:=FrMem;
  end; {Free_Mem}

 Procedure WR(Msg: String; SizeRAM: LongInt);
  { Vype zprvu o velikosti obsazen pamti }
  var
   Q: Byte;
  begin
   Write(Msg,': ');
   For Q:=35 DownTo Length(Msg) do Write('.');
   Writeln(' ',SizeRam:7,' byt.');
  end;

 begin
  ClrScr;        {Budeme alokovat dynamick pole}
  For Q:=1 to Max do PMS[Q]:=New(PMyStr);
  Writeln('V heapu je alokovno dynamick pole');
  Writeln('===================================');
  WR('Celkov voln prostor  v heapu', MemAvail);
  WR('Maxim. souvisl oblast v heapu', MaxAvail);
  WR('Dno heapu a posl.alok. byte',SizeHOccupy);
  WR('Vrchol heapu a  posl.al. byte',SizeHFree);
  WR('Velikost heapu (bez pekryv)'   ,HeapAll);
  WR('Pro pekryvy rezervovno',      SizeOverl);
  WR('Kdov segment',                 SizeCode);
  WR('Datov segment',                 SizeData);
  WR('Dosud voln  st zsobniku',   FreeStack);
  WR('Ji obsazen st zsobnku', OccupyStack);
  WR('Celkov velikost zsobnku',    SizeStack);
  WR('Program obsazuje v pamti RAM',  SizeProg);
  WR('Nejvt voln blok v pamti',   Free_Mem);
  OK:=ReadKey;
  For Q:=1 to Max do begin
   Dispose(PMS[Q]);      {Odstrann dynam. pole}
   PMS[Q]:=Nil;
  end;
  Writeln('Z heapu je uvolnno  dynamick pole');
  Writeln('===================================');
  WR('Celkovy volny prostor  v heapu', MemAvail);
  WR('Maxim. souvisl oblast v heapu', MaxAvail);
  OK:=ReadKey;
 end.
