Program MyFormat;
 {------------------------------------------------------}
 { Program pro formtovn vybran stopy na disket.    }
 { Program je uren pro formtovn disket 5.25"/360KB. }
 {======================================================}
 {Nahran program poskytnu pi zasln diskety a znmky.}
 {   Vt Maleek,  Obrnc mru 9,  796 01 Prostjov.   }
 {------------------------------------------------------}

 uses
  Dos, Crt;
 const
  FormatDisk:Byte= 1; {Mechanika s cl. disk. [A=0, B=1]}
 var
  Tab:     Array [1..36]  of Byte; {9 sekt x 4 byte = 72}
  AktDisk: Byte;   {Implicit. disk ped sputenm progr.}
  R:       Registers;
  Mechan:  Char;
  TypD, CisSt, CisPov: Byte;

 Function ZjistiAktDisk: Byte;
  { Zjist, kter disk. jednot. je prv nastavena jako }
  { implicitn.                                         }
  begin
   R.AH:=$19;                      {Zjisti aktuln disk}
   MsDos(R);                                    {Int 21H}
   ZjistiAktDisk:=R.AL;
  end; {End Of: ZjistiAktDisk}

 Procedure VyprazdniBuff;
  { Vyprzdn buffer disketov mechaniky.               }
  begin
   R.AH:=13;               {Vyprzdni buffer disk. mech.}
   Intr($21,R);
  end; {End Of: VyprazdniBuff}

 Procedure SetAktDisk(NumDisk: Byte);
  { Jako aktuln disketovou jednotku nastav d. mech., }
  { v n bude probhat formtovn.                    }
  begin
   R.AH:=14;           {Nastav implicitni disk. jednotku}
   R.DL:=NumDisk;                              {Jednotka}
   Intr($21,R);                                  {Nastav}
  end; {End Of: SetAktDisk}

 Procedure TypDiskety(TypDPar: Byte);
  { Nastav parametry flopydisketov jednotky.          }
  begin
   R.AH:=23;        {Nastav typ diskety v typu mechaniky}
   R.DL:=FormatDisk;                           {Jednotka}
   R.AL:=TypDPar;                          {Typ diskety:}
         { [1: 360KB v mech. 360; 2: 360KB v mech. 1.2] }
         { [3: 1.2MB v mech. 1.2; 4: 720KB v mech. 1.44]}
         { [5: 1.44  v mech. 1.44;                      }
   Intr($13,R);                                 {"Setuj"}
  end; {End Of: TypDiskety}

 Procedure WaitToPress;
  { Zpsob ukonen programu pi stisku klvesy.       }
  var Ch: Char;
  begin
   If KeyPressed then begin
    Ch:=Readkey;
    Writeln('Program nsiln peruen ...');
    Halt(1);
   end;
  end; {End Of: WaitToPress}

 Procedure Formatuj(St, Hd, PS: byte);
  {Vlastn formtovn vybran stopy.}
  begin
   repeat
    with R do begin
     AH:=5;                           {Formtovn stopy}
     AL:=Ps;                              {Poet sektor}
     CH:=St;                                {slo stopy}
     DH:=Hd;                                     {Povrch}
     DL:=FormatDisk;                           {Jednotka}
     ES:=Seg(Tab);     {Adresa tabulky s popisem sektor}
     BX:=Ofs(Tab[1]);
     Intr($13,R);                           {Formtovn}
    end; {with}
    WaitToPress;
   until R.AH=0;
   writeln('Naformtovna stopa: ',St,' povrch: ',Hd);
  end; {End Of: Formatuj}

 Function TestOKForm(St, Se, Hd: Byte): Boolean;
  { Funkce slou k otestovan uspenosti formtovn a }
  { to tenm vybranho sektoru.  Proto je volna a po }
  { formtovn dan stopy.                             }
  { spn ten => True, jinak False.                 }
  var
   Buf: Array [1..512] of Byte; {Buffer pro ten sektor}
  begin
   repeat
    R.AH:= 2;                   {slo podfunkce - ten}
    R.AL:= 1;                   {Kolik sektor st}
    R.CH:=St;                   {Stopa }
    R.CL:=Se;                   {Sektor}
    R.DH:=Hd;                   {Povrch}
    R.DL:=FormatDisk;           {Identif. disk. jednotky}
    R.ES:=seg(Buf);                      {Adresa bufferu}
    R.BX:=ofs(Buf[1]);
    Intr($13,r);                          {ti sektor(y)}
   until R.AH <> 6; {6 po vm.disk., po 1.pst.na disk.}
   If R.AH=0 then begin               {Sektor se peetl}
    TestOKForm:=True;
    Writeln('spn formtovn: St: ',St,' Sek: ',Se,
    ' Povrch: ',Hd);
   end
   else begin
    TestOKForm:=False;
    writeln('Nespn formtovn: St: ',St,' Sek: ',Se,
    ' Povrch: ',Hd);
   end;
  end; {End Of: TestOKForm}

 Procedure SetTable(StLoc: Byte);
  { Napln tabulku,  kter pedstavuje  devt adresovch}
  { zna. pro devt sektor. Kad sektor je jednoznan}
  { uren jednou adresovou znakou.                     }
  var
   I, J:    Byte;                 {dc promnn cyklu}
  begin
   FillChar(Tab, SizeOf(Tab), #0);      {Vynuluj tabulku}
   For I:=1 to 9 do   {Budu naplovat tab. pro 9 sektor}
   For J:=1 to 4 do {Kad sektor (adr. zn.) vy. 4 byty}
   case J of
    1: Tab[J+(I-1)*4]:= StLoc;  {Stopa, kter bude form.}
    2: Tab[J+(I-1)*4]:= CisPov;    {Povrch, kde je stopa}
    3: Tab[J+(I-1)*4]:= I;       {slo sektoru ve stop}
    4: Tab[J+(I-1)*4]:= 2;       {Dlka sektoru 512 byt}
   end; {case}
  end; {End Of: SetTable}

 Procedure CoFormatovat;
  {Sled dotaz na parametry, kter je teba znt pro s-}
  {pn formtovn poadovan stopy na vybran disket}
  begin
   Write('Disk. mechanika [A/B]: .'#8); {Kter mechanika}
   Readln(Mechan);
   Case UpCase(Mechan) of
    'A': FormatDisk := 0;
    'B': FormatDisk := 1;
   else begin
         Writeln('Chybn specifikace disketov mech.'#7);
         Halt(1);
        end;
   end; {case}
   Writeln('Typ diskety:');    {Jakou disketu formtovat}
   Writeln('1: 360  v mech. 360   2: 360 v mech. 1.2');
   Writeln('3: 1.2  v mech. 1.2   4: 720 v mech. 1.44');
   Writeln('5: 1.44 v mech. 1.44 ');
   Write('Oekvm volbu: ');
   Readln(TypD);
   Write('Povrch, na kterm se stopa nachz: ');
   Readln(CisPov);
   Write('slo stopy pro formatovn: ');   {Uri stopu}
   Readln(CisSt);
  end; {End Of: CoFormatovat}

 begin {---------------  M A I N  ----------------------}
  ClrScr;
  CoFormatovat;            {Kterou oblast disk. formt.?}
  AktDisk:=ZjistiAktDisk;  {Zjisti a ulo aktualn disk}
  SetTable(CisSt);               {Nastav adresov znaky}
  repeat             {Opakovan pokusy o formtovn ...}
   VyprazdniBuff;           {Vyprzdni buffer disk.mech.}
   SetAktDisk(FormatDisk);   {Pepni se na form. mech.}
   TypDiskety(TypD);           {"Nesetuj" disk.mechaniku}
   Formatuj(CisSt,CisPov,9);   {Formtovn  jedn stopy}
   WaitToPress;                {Umon nsiln peruen}
  until TestOkForm(CisSt,1,CisPov);   {... dokud nen OK}
  Sound(2000);Delay(200); Sound(440);Delay(80);  NoSound;
  Write('P r e s s   a n y   k e y . . . . ');
  Mechan:=ReadKey;
  Writeln;
  SetAktDisk(AktDisk);{Pv. akt. disk se stane opt akt.}
 end. {--------------  End Of:  M A I N  ---------------}
