{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O-,R-,S-,V-,X+}
unit MyList;                                       { MYLIST.PAS }

interface

const MAX_ZAZNAM = 65535;
                                                                 {
             V y z n a m   s y m b o l o v

  p                     = smernk na zoznam
  z1                    = smernk na zaciatok bloku zznamov
  z2                    = smernk na koniec bloku zznamov
  n                     = velkost zznamu v bajtoch
  Dopredu               = smerom od zaciatku ku koncu zoznamu
  Dozadu                = smerom od konca k zaciatku zoznamu
  PredAktulny          = ako Dopredu
  ZaAktualny            = ako Dozadu
  NastavAktualnePoradie = Poradie podla Aktual
  NastavAktualnyZaznam  = Aktual a Poradie podla n
                                                                 }

function  AktualnyZaznamDopredu ( var p   : pointer ): boolean;

function  AktualnyZaznamDozadu  ( var p   : pointer ): boolean;

procedure InitZoznam            ( var p   : pointer;
                                      n   : word );

procedure NastavAktualnePoradie ( var p   : pointer );

procedure NastavAktualnyZaznam  ( var p   : pointer;
                                      n   : word    );

procedure NastavNaKoniec        ( var p   : pointer );

procedure NastavNaZaciatok      ( var p   : pointer );

function  NovyZaznamPredAktualny( var p   : pointer ): boolean;

procedure PremiestniZaAktualny  ( var p,
                                      z1,
                                      z2  : pointer );

procedure PrvyZaznam            ( var p   : pointer );

procedure ZrusZaznam            ( var p   : pointer;
                                  var z   : pointer );

implementation

type TZaznam    = ^Zaznam;
     Zaznam     = record
                    Predchodca,
                    Naslednik           : TZaznam
                  end;
     TZoznam    = record
                    VelkostZaznamu,
                    PocetZaznamov,
                    PoradieZaznamu      : word;
                    Zaciatok,
                    Koniec,
                    Aktual              : TZaznam
                  end;

var pZaznam     : TZaznam;

function AktualnyZaznamDopredu;       { Smerom ku koncu zoznamu }
begin
  with TZoznam(p^) do
    if (Aktual = NIL) or (Aktual^.Naslednik = NIL) then
      AktualnyZaznamDopredu:=FALSE
    else
      begin
        Aktual:=Aktual^.Naslednik;
        Inc(PoradieZaznamu);
        AktualnyZaznamDopredu:=TRUE
      end
end;

function AktualnyZaznamDozadu;      { Smerom k zaciatku zoznamu }
begin
  with TZoznam(p^) do
    if (Aktual = NIL) or (Aktual^.Predchodca = NIL) then
      AktualnyZaznamDozadu:=FALSE
    else
      begin
        Aktual:=Aktual^.Predchodca;
        Dec(PoradieZaznamu);
        AktualnyZaznamDozadu:=TRUE
      end
end;

procedure InitZoznam;
begin
  with TZoznam(p^) do
  begin
    Zaciatok:=NIL;
    Koniec:=NIL;
    Aktual:=NIL;
    VelkostZaznamu:=n;
    PocetZaznamov:=0;
    PoradieZaznamu:=0
  end
end;

procedure NastavAktualnePoradie;
begin
  with TZoznam(p^) do
    if Zaciatok <> NIL then
    begin
      pZaznam:=Zaciatok;
      PoradieZaznamu:=1;
      while (pZaznam <> Aktual) do
      begin
        Inc(PoradieZaznamu);
        pZaznam:=pZaznam^.Naslednik
      end
    end
    else
      PoradieZaznamu:=0
end;

procedure NastavAktualnyZaznam;
begin
  with TZoznam(p^) do
    if PoradieZaznamu <> n then
    begin
      if PoradieZaznamu < n then
        for n:=PoradieZaznamu to n-1 do
          AktualnyZaznamDopredu(p)
      else
        for n:=PoradieZaznamu downto n+1 do
          AktualnyZaznamDozadu(p)
    end
end;

procedure NastavNaKoniec;
begin
  with TZoznam(p^) do
  begin
    Aktual:=Koniec;
    PoradieZaznamu:=PocetZaznamov
  end
end;

procedure NastavNaZaciatok;
begin
  with TZoznam(p^) do
  begin
    Aktual:=Zaciatok;
    PoradieZaznamu:=1
  end
end;

function  NovyZaznamOK( var p : pointer ): boolean;
begin
  with TZoznam(p^) do
  begin
    if (MaxAvail < VelkostZaznamu) or
      (PocetZaznamov = MAX_ZAZNAM) then
    begin
      NovyZaznamOK:=FALSE;
      Exit
    end;
    GetMem(pZaznam,VelkostZaznamu)
  end;
  NovyZaznamOK:=TRUE;
  pZaznam^.Predchodca:=NIL;
  pZaznam^.Naslednik:=NIL
end;

function NovyZaznamPredAktualny;     { Smerom dopredu, ku koncu }
begin
  NovyZaznamPredAktualny:=FALSE;
  if not NovyZaznamOK(p) then
    Exit;
  with TZoznam(p^) do
    if Aktual = NIL then
      PrvyZaznam(p)
    else
      begin
        if Aktual^.Naslednik = NIL then
        begin
          Aktual^.Naslednik:=pZaznam;
          pZaznam^.Predchodca:=Aktual;
          pZaznam^.Naslednik:=NIL;
          Aktual:=pZaznam;
          Koniec:=pZaznam;
          if Zaciatok^.Naslednik = NIL then
            Zaciatok^.Naslednik:=Aktual
        end
        else
          begin
            pZaznam^.Predchodca:=Aktual;
            pZaznam^.Naslednik:=Aktual^.Naslednik;
            Aktual^.Naslednik^.Predchodca:=pZaznam;
            Aktual^.Naslednik:=pZaznam;
            Aktual:=pZaznam
          end;
        Inc(PocetZaznamov);
        Inc(PoradieZaznamu)
      end;
  NovyZaznamPredAktualny:=TRUE
end;

procedure PremiestniZaAktualny;     { Smerom k zaciatku zoznamu }
begin
  with TZoznam(p^) do
  begin
    if TZaznam(z1)^.Predchodca = NIL then
    begin
      TZaznam(z2)^.Naslednik^.Predchodca:=NIL;
      Zaciatok:=TZaznam(z2)^.Naslednik
    end
    else
      if TZaznam(z2)^.Naslednik = NIL then
      begin
        TZaznam(z1)^.Predchodca^.Naslednik:=NIL;
        Koniec:=TZaznam(z1)^.Predchodca
      end
      else
        begin
          TZaznam(z1)^.Predchodca^.Naslednik:=
            TZaznam(z2)^.Naslednik;
          TZaznam(z2)^.Naslednik^.Predchodca:=
            TZaznam(z1)^.Predchodca
        end;
    if Aktual^.Predchodca = NIL then
    begin
      TZaznam(z1)^.Predchodca:=NIL;
      Zaciatok:=z1
    end
    else
      begin
        Aktual^.Predchodca^.Naslednik:=z1;
        TZaznam(z1)^.Predchodca:=Aktual^.Predchodca
      end;
    TZaznam(z2)^.Naslednik:=Aktual;
    Aktual^.Predchodca:=z2
  end;
  NastavAktualnePoradie(p)
end;

procedure PrvyZaznam;
begin
  with TZoznam(p^) do
  begin
    Zaciatok:=pZaznam;
    Koniec:=pZaznam;
    Aktual:=pZaznam;
    PocetZaznamov:=1;
    PoradieZaznamu:=1
  end
end;

procedure ZrusZaznam;
begin
  if z <> NIL then
    with TZoznam(p^), TZaznam(z)^ do
    begin
      pZaznam:=z;
      if z = Zaciatok then
      begin
        Zaciatok:=Zaciatok^.Naslednik;
        if Zaciatok <> NIL then
          Zaciatok^.Predchodca:=NIL;
        z:=Zaciatok
      end
      else
        if z = Koniec then
        begin
          Koniec:=Koniec^.Predchodca;
          if Koniec <> NIL then
            Koniec^.Naslednik:=NIL;
          z:=Koniec;
          if pZaznam = Aktual then
            Dec(PoradieZaznamu)
        end
        else
          begin
            Predchodca^.Naslednik:=Naslednik;
            Naslednik^.Predchodca:=Predchodca;
            z:=Naslednik
          end;
      if pZaznam = Aktual then
        Aktual:=z;
      FreeMem(pZaznam,VelkostZaznamu);
      Dec(PocetZaznamov)
    end
end;

end.
