{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X+}
unit MyWindow;                                   { MYWINDOW.PAS }

interface

uses Crt,Dos;

type  TStr60                     = string[60];
      TStr77                     = string[77];
      TStr12                     = string[12];
      TPtrStr77                  = ^TStr77;
      TColorBase                 = array[boolean] of byte;
      TKurzor                    = (normalny,plny,skryty);
      TPovod                     = ^PovodneOkno;
      PovodneOkno                = record
                                     StlpecMin,
                                     RiadokMin,
                                     StlpecMax,
                                     RiadokMax,
                                     StlpecKurzor,
                                     RiadokKurzor,
                                     ExistAttr     : byte;
                                     StavKurzora   : TKurzor
                                   end;
      TObsah                     = ^ObsahOkna;
      ObsahOkna                  = record
                                     StlpecMin,
                                     RiadokMin,
                                     StlpecMax,
                                     RiadokMax     : byte;
                                     Obsah         : array[1..
                                                     6000] of word
                                   end;
      TObsahRiadku               = ^ObsahRiadku;
      ObsahRiadku                = array[1..240] of byte;

const ZvislaCiara                = 186;
      VodorovnaCiara             = 205;
      NOVY_RIADOK                = #13#10;
      BOARD                      = #176;
      MEDZERA                    = #32;
      VIDEO                      = word(256);
      BlueOnCyan                 = Crt.Blue+Crt.Cyan*16;
      CyanOnBlue                 = Crt.Cyan+Crt.Blue*16;
      BlueOnLightGray            = Crt.Blue+Crt.LightGray*16;
      YellowOnCyan               = Crt.Yellow+Crt.Cyan*16;
      YellowOnBlue               = Crt.Yellow+Crt.Blue*16;
      YellowOnRed                = Crt.Yellow+Crt.Red*16;
      LightGrayOnBlue            = Crt.LightGray+Crt.Blue*16;
      LightCyanOnBlue            = Crt.LightCyan+Crt.Blue*16;
      WhiteOnBlue                = Crt.White+Crt.Blue*16;
      LightGrayOnBlack           = Crt.LightGray+Crt.Black*16;
      BlackOnLightGray           = Crt.Black+Crt.LightGray*16;
      RedOnLightGray             = Crt.Red+Crt.LightGray*16;
      BaseAttr      : TColorBase = (LightGrayOnBlack,
                                    YellowOnBlue);
      AttrInfo      : TColorBase = (BlackOnLightGray,
                                    BlueOnLightGray);
      AttrMessage   : TColorBase = (BlackOnLightGray,
                                    YellowOnRed);
      _NAVOD_TLAC   : string[49] = '<C>ontinue|<Enter>   <P>rin'+
                                    'tScreen   <End>|<Esc>';
      _STLAC        : string[23] = 'Stlac lubovolnu klavesu';
      _CHYBA_TLAC   : string[15] = 'Chyba tlaciarne';
      _PAMAT        : string[17] = 'Nedostatok pamate';

var   DISPLAY_ROW   : byte absolute $0040:$0084;
      DISPLAY_COL   : byte absolute $0040:$004A;
      COLOR         : boolean;
      FirstMode     : word;
      StavKurzora   : TKurzor;
      Regs          : Dos.Registers;
      VideoWord,
      VideoAttr     : word;
      pNavod,
      pStlac,
      pChybaTlace,
      pPamat        : TPtrStr77;

procedure CakajNaStlacenieKlavesy;

function  CenterText        (     Str77     : TStr77;
                                  Sirka     : byte;
                                  Znak      : char ): TStr77;

function  GetVideoRam       (     Col,
                                  Row       : byte ): word;

function  KontrolaTlaciarne: boolean;

procedure KritickaChyba     (     Oznam     : TStr77 );

procedure NastavKurzor      (     Stav      : TKurzor );

procedure OdlozObsahOkna    ( var pObsah    : TObsah );

procedure OdlozPovodneOkno  ( var pPovod    : TPovod );

procedure OdlozObsahRiadku  (     Riadok    : byte;
                              var p         : TObsahRiadku );

procedure OramujOkno;

function  RepeatChar        (     Count     : byte;
                                  ThisChar  : char ): string;

procedure SetVideoRam       (     Col, Row  : byte;
                                  VideoWord : word );

procedure StandardnaObrazovka;

function  StrLongInt        (     LongValue : longint ): TStr12;

function  StrReal           (     RealValue : real ): TStr12;

procedure TlacObrazovky     ( var Detect    : char );

procedure VideoText         (     Zaciatok,
                                  Sirka,
                                  Riadok    : byte;
                                  TextInfo  : TStr77;
                                  DoplnZnak : char;
                                  Atribut   : byte );

procedure VratObsahOkna     ( var pObsah    : TObsah );

procedure VratPovodneOkno   ( var pPovod    : TPovod );

procedure VratObsahRiadku   (     Riadok    : byte;
                              var p         : TObsahRiadku);

procedure VypisChybovyOznam (     Oznam     : TStr77 );

procedure VypisTitulOkna    (     Titul     : TStr77 );

procedure VyprazdniObsahOkna( var pObsah    : TObsah );

procedure ZakladneOkno;

implementation

type  TPtrBase                    = array[boolean] of word;
      TTvar                       = array[TKurzor] of byte;

const BaseAddress   : TPtrBase    = ($B000,$B800);
      LavyHornyRoh                = 201;
      PravyHornyRoh               = 187;
      LavyDolnyRoh                = 200;
      PravyDolnyRoh               = 188;
      TvarKurzora   : TTvar       = (6,1,32);
      pPovod        : TPovod      = NIL;
      pObsah        : TObsah      = NIL;

var   Base,                      { Adresa zaciatku videostrnky }
      i,j,n         : word;
      ExitSave      : pointer;

procedure KritickaChyba;
begin
  StandardnaObrazovka;
  VypisChybovyOznam(Oznam);
  Halt(1)
end;

procedure NastavKurzor;
begin
  with Regs do
  begin
    AH:=1;
    CH:=TvarKurzora[Stav];
    CL:=7
  end;
  Intr(16,Regs);
  StavKurzora:=Stav
end;

function RepeatChar;
begin
  asm
    LES   DI,[@Result]
    MOV   AL,Count
    CLD
    STOSB
    MOV   CL,AL
    XOR   CH,CH
    MOV   AL,ThisChar
    REP   STOSB
  end
end;

procedure SetVideoRam;
begin                                                {
    byte Znak a byte atribt sa kduje do word takto:
    Ŀ
      VideoWord:=Znak+Attr*256 
    Ĵ
        byte         byte     
    Ĵ
        Znak         Attr     
    Lo(VideoWord)Hi(VideoWord)
                        }
  MemW[Base:((Row*DISPLAY_COL)+Col)*2]:=VideoWord
end;

function GetVideoRam;
begin
  GetVideoRam:=MemW[Base:((Row*DISPLAY_COL)+Col)*2]
end;

procedure ZakladneOkno;
begin
  NastavKurzor(skryty);
  VideoWord:=byte(BOARD)+BaseAttr[COLOR]*VIDEO;
  for i:=0 to DISPLAY_COL-1 do
    for j:=0 to DISPLAY_ROW do
      SetVideoRam(i,j,VideoWord)
end;

procedure StandardnaObrazovka;
begin
  NastavKurzor(normalny);
  Crt.TextMode(FirstMode)
end;

procedure OdlozObsahRiadku;
begin
  GetMem(p,DISPLAY_COL*2);
  Move(Mem[Base:(Riadok-1)*DISPLAY_COL*2],p^,DISPLAY_COL*2)
end;

procedure VratObsahRiadku;
begin
  Move(p^,Mem[Base:(Riadok-1)*DISPLAY_COL*2],DISPLAY_COL*2);
  FreeMem(p,DISPLAY_COL*2)
end;

procedure VideoText;
begin
  VideoAttr:=Atribut*VIDEO;
  if Zaciatok+Sirka-1 > DISPLAY_COL then
  begin
    Zaciatok:=1;
    Sirka:=DISPLAY_COL
  end;
  j:=0;
  for i:=Zaciatok-1 to Zaciatok+Sirka-2 do
  begin
    Inc(j);
    if j > byte(TextInfo[0]) then
      VideoWord:=VideoAttr+byte(DoplnZnak)
    else
      VideoWord:=VideoAttr+byte(TextInfo[j]);
    SetVideoRam(i,Riadok-1,VideoWord)
  end
end;

procedure CakajNaStlacenieKlavesy;
var p : TObsahRiadku;

begin
  OdlozObsahRiadku(DISPLAY_ROW+1,p);
  VideoText(1,DISPLAY_COL,DISPLAY_ROW+1,MEDZERA+pStlac^,
    MEDZERA,AttrInfo[COLOR]);
  repeat
    ReadKey
  until not KeyPressed;
  VratObsahRiadku(DISPLAY_ROW+1,p)
end;

procedure VypisChybovyOznam;
var Stlpec,
    Sirka,
    Riadok  : byte;
    p       : TObsahRiadku;

begin
  if byte(Oznam[0]) <> 0 then
    if Oznam[1] <> ' ' then
      Oznam:=' '+Oznam;
  Sirka:=Lo(WindMax)-Lo(WindMin)-1;
  if byte(Oznam[0]) <= Sirka then
  begin
    Riadok:=Hi(WindMin)+2;
    Stlpec:=Lo(WindMin)+2
  end
  else
    begin
      Riadok:=DISPLAY_ROW;
      Stlpec:=2;
      Sirka:=DISPLAY_COL-2
    end;
  OdlozObsahRiadku(Riadok,p);
  VideoText(Stlpec,Sirka,Riadok,Oznam,MEDZERA,
    AttrMessage[COLOR]);
  CakajNaStlacenieKlavesy;
  VratObsahRiadku(Riadok,p)
end;

function KontrolaTlaciarne;
const ControlBit : array[3..7] of byte = (8,0,32,64,0);

begin
  with Regs do
  begin
    { Cyklicka kontrola pripojenosti tlaciarne na 0..3 porte }
    DX:=0;
    repeat
      AH:=2;
      Intr(23,Regs);
      Inc(DX)
    until (DX = 3) or (AH and 16 = 16);
    { Cyklicka kontrola pripravenosti tlaciarne }
    DX:=4;
    for i:=3 to 7 do
    begin
      DX:=DX*2;
      if AH and DX = ControlBit[i] then
      begin
        VypisChybovyOznam(pChybaTlace^);
        KontrolaTlaciarne:=FALSE;
        Exit
      end
    end
  end;
  KontrolaTlaciarne:=TRUE
end;

function  StrReal;
var Str32  : string[32];
    nStr32 : byte absolute Str32;

begin
  Str(RealValue:32:10,Str32);
  while (nStr32 <> 1) and (Str32[1] = ' ') do
    Delete(Str32,1,1);
  if Pos('.',Str32) <> 0 then
    while (nStr32 <> 0) and (Str32[nStr32] = '0') do
      Dec(Str32[0]);
  if (nStr32 <> 0) and (Str32[nStr32] = '.') then
    Dec(Str32[0]);
  StrReal:=Str32
end;

function StrLongInt;
var StrPom : TStr12;

begin
  Str(LongValue,StrPom);
  StrLongInt:=StrPom
end;

function CenterText;
begin
  if byte(Str77[0]) > Sirka then
    byte(Str77[0]):=Sirka;
  n:=(Sirka-byte(Str77[0])) div 2;
  Str77:=RepeatChar(n,Znak)+Str77;
  n:=Sirka-byte(Str77[0]);
  CenterText:=Str77+RepeatChar(n,Znak)
end;

procedure OramujOkno;
begin
  VideoWord:=TextAttr*VIDEO;       { Zakodovany atribut do word }
  SetVideoRam(Lo(WindMin),Hi(WindMin),VideoWord+LavyHornyRoh);
  SetVideoRam(Lo(WindMax),Hi(WindMin),VideoWord+PravyHornyRoh);
  SetVideoRam(Lo(WindMin),Hi(WindMax),VideoWord+LavyDolnyRoh);
  SetVideoRam(Lo(WindMax),Hi(WindMax),VideoWord+PravyDolnyRoh);
  for i:=Lo(WindMin)+1 to Lo(WindMax)-1 do
  begin
    SetVideoRam(i,Hi(WindMin),VideoWord+VodorovnaCiara);
    SetVideoRam(i,Hi(WindMax),VideoWord+VodorovnaCiara)
  end;
  for i:=Hi(WindMin)+1 to Hi(WindMax)-1 do
  begin
    SetVideoRam(Lo(WindMin),i,VideoWord+ZvislaCiara);
    SetVideoRam(Lo(WindMax),i,VideoWord+ZvislaCiara)
  end
end;

procedure VypisTitulOkna;
begin
  i:=Lo(WindMax)-Lo(WindMin)-3;
  if (i < 1) or (i > 77) then
    Exit;
  while (byte(Titul[0]) > 0) and (Titul[1] = ' ') do
    Delete(Titul,1,1);
  while (byte(Titul[0]) > 0) and
    ((Titul[byte(Titul[0])] = ' ') or (byte(Titul[0]) > i-2)) do
      Dec(Titul[0]);
  if byte(Titul[0]) > 0 then
    Titul:=' '+Titul+' ';
  Titul:=CenterText(Titul,i,char(VodorovnaCiara));
  i:=Lo(WindMin)+(Lo(WindMax)-Lo(WindMin)+1-byte(Titul[0])) div 2;
  j:=0;
  for i:=i to i+byte(Titul[0])-1 do
  begin
    Inc(j);
    if byte(Titul[j]) = VodorovnaCiara then
      VideoWord:=TextAttr*VIDEO
    else
      VideoWord:=AttrInfo[COLOR]*VIDEO;
    SetVideoRam(i,Hi(WindMin),VideoWord+byte(Titul[j]))
  end;
end;

procedure VyprazdniObsahOkna;
begin
  if pObsah <> NIL then
    with pObsah^ do
    begin
      FreeMem(pObsah,4+(word(StlpecMax-StlpecMin+1)*
        word(RiadokMax-RiadokMin+1))*2);
      pObsah:=NIL
    end
end;

procedure OdlozObsahOkna;
begin
  n:=4+(word(Lo(Crt.WindMax)-Lo(Crt.WindMin)+1)*
    word(Hi(Crt.WindMax)-Hi(Crt.WindMin)+1))*2;
  if MaxAvail < n then
    KritickaChyba(pPamat^);
  VyprazdniObsahOkna(pObsah);
  GetMem(pObsah,n);
  with pObsah^ do
  begin
    StlpecMin:=Lo(Crt.WindMin);
    StlpecMax:=Lo(Crt.WindMax);
    RiadokMin:=Hi(Crt.WindMin);
    RiadokMax:=Hi(Crt.WindMax);
    i:=1;
    n:=StlpecMax-StlpecMin+1;
    for j:=RiadokMin to RiadokMax do
    begin
      Move(Mem[Base:((j*DISPLAY_COL)+StlpecMin)*2],Obsah[i],n*2);
      Inc(i,n)
    end
  end
end;

procedure VratObsahOkna;
begin
  if pObsah <> NIL then
    with pObsah^ do
    begin
      i:=1;
      n:=StlpecMax-StlpecMin+1;
      for j:=RiadokMin to RiadokMax do
      begin
        Move(Obsah[i],Mem[Base:(j*DISPLAY_COL+StlpecMin)*2],n*2);
        Inc(i,n)
      end;
      VyprazdniObsahOkna(pObsah)
    end
end;

procedure OdlozPovodneOkno;
begin
  if pPovod = NIL then
  begin
    if MaxAvail < SizeOf(PovodneOkno) then
      KritickaChyba(pPamat^);
    New(pPovod)
  end;
  with pPovod^ do
  begin
    StlpecMin:=Lo(Crt.WindMin)+1;
    RiadokMin:=Hi(Crt.WindMin)+1;
    StlpecMax:=Lo(Crt.WindMax)+1;
    RiadokMax:=Hi(Crt.WindMax)+1;
    StlpecKurzor:=Crt.WhereX;
    RiadokKurzor:=Crt.WhereY;
    ExistAttr:=Crt.TextAttr
  end;
  pPovod^.StavKurzora:=StavKurzora
end;

procedure VratPovodneOkno;
begin
  if pPovod <> NIL then
  begin
    with pPovod^ do
    begin
      Crt.Window(StlpecMin,RiadokMin,StlpecMax,RiadokMax);
      NastavKurzor(pPovod^.StavKurzora);
      Crt.TextAttr:=ExistAttr;
      Crt.GoToXY(StlpecKurzor,RiadokKurzor)
    end;
    Dispose(pPovod);
    pPovod:=NIL
  end
end;

procedure Tlac;
begin
  if KontrolaTlaciarne then
  begin
    VideoText(1,DISPLAY_COL,DISPLAY_ROW+1,'',MEDZERA,
      AttrInfo[COLOR]);
    Intr(5,Regs);
    VideoText(1,DISPLAY_COL,DISPLAY_ROW+1,CenterText(pNavod^,
      DISPLAY_COL,MEDZERA),MEDZERA,AttrInfo[COLOR])
  end
end;

procedure TlacObrazovky;
var p      : TObsahRiadku;
    Koniec : boolean;

begin
  OdlozObsahRiadku(DISPLAY_ROW+1,p);
  VideoText(1,DISPLAY_COL,DISPLAY_ROW+1,
    CenterText(pNavod^,DISPLAY_COL,MEDZERA),MEDZERA,
      AttrInfo[COLOR]);
  Koniec:=FALSE;
  repeat
    Detect:=UpCase(ReadKey);
    case Detect of
      #0  : begin
              Detect:=ReadKey;
              Koniec:=Detect = #79
            end;
      #13,
      #27,
      #67 : Koniec:=TRUE;
      #80 : Tlac
    end     { case }
  until KONIEC;
  VratObsahRiadku(DISPLAY_ROW+1,p)
end;

procedure MyExitProc; FAR;
begin
  StandardnaObrazovka;
  VratObsahOkna(pObsah);
  VratPovodneOkno(pPovod);
  ExitProc:=ExitSave
end;

begin
  ExitSave:=ExitProc;
  ExitProc:=@MyExitProc;
  FirstMode:=Crt.LastMode;
  Base:=BaseAddress[FirstMode <> Crt.MONO];
  COLOR:=FirstMode <> Crt.MONO;
  NastavKurzor(normalny);
  { Takto mozno preadresovat na text v nrodnej reci }
  pNavod:=@_NAVOD_TLAC;
  pStlac:=@_STLAC;
  pChybaTlace:=@_CHYBA_TLAC;
  pPamat:=@_PAMAT;
  OdlozObsahOkna(pObsah);
  OdlozPovodneOkno(pPovod);
  StandardnaObrazovka
end.