program ScreenSaver;
{ PC World - inspirace pro vas vlastni setric obrazovky }
{$X+}
{ definice dialogu }
{$R scrnsav.res}

uses OWindows, ODialogs, WinProcs, WinTypes, Strings;

{ POZOR! pod tmto jmnem bude vystupovat v Control Panelu }

{$D SCRNSAVE:PC World Screen Saver}


type
  { objekt etie obrazovky }
  PScrnSavWindow = ^TScrnSavWindow;
  TScrnSavWindow = object(TWindow)
    PrevPoint: TPoint;
    constructor Init(AParent: PWindowsObject; ATitle: PChar);
    destructor Done; virtual;
    function GetClassName: PChar; virtual;
    procedure GetWindowClass(var AWndClass: TWndClass); virtual;
    procedure SetupWindow; virtual;
    procedure DefWndProc(var Msg: TMessage); virtual;
    procedure WMSysCommand(var Msg: TMessage);
      virtual wm_First + wm_SysCommand;
    { vkonn procedura pro vykreslen obrazovky }
    procedure AnimateScreen; virtual;
  end;

  { nutn objekt aplikace }
  PScrnSavApp = ^TScrnSavApp;
  TScrnSavApp = object(TApplication)
    ConfigDialog: PDlgWindow;
    ScrnSavWindow: PScrnSavWindow;
    procedure InitMainWindow; virtual;
    function IdleAction: Boolean; virtual;

    procedure InitScrnSavWindow; virtual;
    procedure InitConfigDialog; virtual;
  end;

{ systmov konstanta Windows, nezahrnut
  ve WinProcs a WinTypes }
const
  sc_ScreenSave = $F140;


{ definice objektu etie }

constructor TScrnSavWindow.Init;
begin
  TWindow.Init(AParent, ATitle);
  ShowCursor(False);
  Attr.Style := ws_Popup;
end;

destructor TScrnSavWindow.Done;
begin
  ShowCursor(True);
  TWindow.Done;
end;

function TScrnSavWindow.GetClassName: PChar;
begin
  GetClassName := 'ScreenSaver.BorPascalScreenSaver';
end;

procedure TScrnSavWindow.GetWindowClass;
begin
  TWindow.GetWindowClass(AWndClass);
  with AWndClass do
  begin
    hIcon := LoadIcon(0, idi_Application);
    Style := Style or cs_SaveBits;
    hbrBackground := GetStockObject(BLACK_BRUSH);
  end;
end;

procedure TScrnSavWindow.SetupWindow;
var
  R: TRect;
  Desktop: hWnd;
begin
  inherited SetupWindow;
  GetCursorPos(PrevPoint); { uloit pozici myi pro zjitn
   jejho pohybu }
  Desktop := GetDesktopWindow;
  GetWindowRect(Desktop, R); { prava okna podle rozmr obrazovky }
  with R do MoveWindow(HWindow, Left, Top, Right, Bottom, True);
end;

procedure TScrnSavWindow.DefWndProc;
begin
  case Msg.Message of
    wm_MouseMove:
      if Msg.LParam <> Longint(PrevPoint) then
      PostMessage(HWindow, wm_Close, 0, 0);
    wm_Activate,
    wm_ActivateApp:
      if Msg.WParam = 0 then PostMessage(HWindow, wm_Close, 0, 0);
    wm_KeyDown, wm_SysKeyDown,
    wm_LButtonDown,
    wm_MButtonDown,
    wm_RButtonDown: PostMessage(HWindow, wm_Close, 0, 0);
  end;
  TWindow.DefWndProc(Msg);
end;

procedure TScrnSavWindow.WMSysCommand;
begin
  if Msg.wParam and $FFF0 = sc_ScreenSave then
    Msg.Result := 1
  else
    DefWndProc(Msg);
end;

{ vkonn procedura pro pekryt v potomcch TScrnSavWindow }
procedure TScrnSavWindow.AnimateScreen;
begin
end;

{ definice objektu aplikace }

procedure TScrnSavApp.InitMainWindow;
begin
  ScrnSavWindow := nil;
  if (StrIComp(CmdLine, '/c') = 0) or (StrIComp(CmdLine, '-c') = 0) then
  begin
    InitConfigDialog;
    MainWindow := ConfigDialog;
  end
  else
  begin
    InitScrnSavWindow;
    MainWindow := ScrnSavWindow;
  end;
end;

function TScrnSavApp.IdleAction: Boolean;
begin
  if ScrnSavWindow <> nil then
    ScrnSavWindow^.AnimateScreen;
  IdleAction := True;
end;

procedure TScrnSavApp.InitScrnSavWindow;
begin
  ScrnSavWindow := New(PScrnSavWindow, Init(nil, nil));
end;

procedure TScrnSavApp.InitConfigDialog;
begin
  { nejjednodu mon dialog - pouze vype zprvu }
  ConfigDialog := New(PDlgWindow, Init(nil, 'DLG_CONFIG'));
end;

var
  SSaver: TScrnSavApp;
begin
  SSaver.Init('ScreenSaver.BorPascalScreenSaver');
  SSaver.Run;
  SSaver.Done;
end.

{
Vpis souboru SCRNSAV.RC
Resource  soubor ve  zdrojovm tvaru ulote  pod  jmnem  SCRNSAV.RC,  nahrajte  do Resource Workshopu a ulote pod jmnem SCRNSAV.RES. Nutn pro kompilaci.}

{
DLG_CONFIG DIALOG 19, 36, 142, 52
STYLE DS_MODALFRAME | WS_POPUP | WS_CAPTION | WS_SYSMENU
CAPTION "Screen saver options"
BEGIN
  CONTROL "This screen saver has no options...", -1, "STATIC",
    SS_LEFT | WS_CHILD | WS_VISIBLE | WS_GROUP, 10, 10, 123, 36
  CONTROL "OK", 1, "BUTTON",
    BS_DEFPUSHBUTTON | WS_CHILD | WS_VISIBLE | WS_TABSTOP, 53, 33, 35, 14
END}