/* Rezidentn programy, 4.dl */
/* Jan p, IDG Testcentrum */
/*---------------------------------------------------- */

/* []-------------------------------------------------[] */
/* |                ScreenSaver-DEMO1                  | */
/* |       Pklad k serilu o TSR pro PC WORLD        | */
/* |        Peloit s Unsigned characters ON!         | */
/* |             Aktivace Ctrl+Alt+F12.                | */
/* |  Umon oznait vez textov obrazovky a ulo   | */
/* |  jej do aktulnho adrese pod jmnem SCREEN.SAV | */
/* []-------------------------------------------------[] */

# include <bios.h>                  /* def. soubor pro pouit slueb BIOSu */
# include <dos.h>                   /* def. soubor pro pouit slueb DOSu  */
# include <stdio.h>                 /* def. soubor standardnch I/O funkc  */

# define ScanCode 0x58                      /* kd aktivan klvesy  (F12) */
# define ShiftMask 0x0C            /* maska pznak peaova (Ctrl+Alt) */

extern unsigned _stklen  = 0x80;           /* nastaven velikosti zsobnku */
extern unsigned _heaplen = 0x480;     /* nastaven velikosti blzk hromady */

union REGS Rg;            /* struktura pro pedvn registrovch parametr */
struct SREGS Seg; /* struktura pro reg. parametry v segmentovch registrech */

unsigned IntSP,                 /* hodnota registru SP peruenho programu */
         IntSS,                 /* hodnota registru SS peruenho programu */
         IntPSP,                         /* adresa PSP peruenho programu */
         MySS,              /* registr SS rezidentu, uchovan pi instalaci */
         Stack;             /* registr SP rezidentu, uchovan pi instalaci */

char VideoMode,                                       /* aktuln  videomd */
     NCol,                             /* poet textovch sloupc obrazovky */
     LRow;                    /* slo poslednho textovho dku obrazovky */

char far *DosFlagPtr;                  /* ukazatel na pznak aktivity dosu */
char far *Shifts = MK_FP(0, 0x0417);  /* ukazatel na bit. masku peaova */

unsigned VideoRAM;    /* aktuln segmentov adresa VideoRAM v text. reimu */

char Run    = 0;                               /* pznak vlastn aktivity  */
char SSFlag = 0;                           /* pznak poadavku na aktivaci */
char Break  = 0;                                      /* pznak Ctrl-Break */

void interrupt (*OldTimer)(void);           /* pv. vektor obsluhy asovae */
void interrupt (*OldKeyboard)(void);      /* pv. vektor obsluhy klvesnice */
void interrupt (*OldBreak)(void);         /* pv. vektor obsluhy Ctrl-Break */
void interrupt (*OldCritErr)(void);      /* pv. vektor obsluhy krit. chyby */
void interrupt (*OldDosSafe)(void);                  /* pv. vektor INT 28h */

void STBeep(unsigned Length, unsigned High)
{
 sound(High); delay(Length); nosound();
}

/* ------------------------------------------------------------------------ */
/* Funkce SwapAttr zinverzn znak v textovm reimu vmnou atribut barvy  */
/* textu (bity 0-2) a barvy pozad (bity 4-6).                              */
/* ------------------------------------------------------------------------ */
void SwapAttr(char X, char Y)
{
 char far *ScrAttr;

 ScrAttr = MK_FP(VideoRAM, Y*2*NCol + X*2+1);
 *ScrAttr = (((*ScrAttr >> 4) + (*ScrAttr << 4)) & 0x77) | (*ScrAttr & 0x88);
}

/* ------------------------------------------------------------------------ */
/* Funkce SwapLine "zinverzn" textov dek v zadanm rozsahu pomoc       */
/* voln funkce SwapAttr                                                   */
/* ------------------------------------------------------------------------ */
void SwapLine(char X1, char X2, char Y)
{
 for (; X1 <= X2; X1++) SwapAttr(X1, Y);
}

/* ------------------------------------------------------------------------ */
/* Funkce SwapColumn "zinverzn" textov sloupec v zadanm rozsahu pomoc   */
/* voln funkce SwapAttr                                                   */
/* ------------------------------------------------------------------------ */
void SwapColumn(char X, char Y1, char Y2)
{
 for (; Y1 <= Y2; Y1++) SwapAttr(X, Y1);
}

/* ------------------------------------------------------------------------ */
/* Funkce SaveScreen tvo vlasn funkn jdro programu. Je volna pi     */
/* splnn podmnek nutnch pro bezkolizn aktivaci TSR programu.           */
/* ------------------------------------------------------------------------ */
void SaveScreen(void)
{
 typedef struct
  { char X, Y; } POS;

 POS MyCurs = {0, 0};       /* souadnice aktuln polohy vlastnho kurzoru */
 POS WinTop = {0, 0};   /* souadnice levho hornho rohu oznaenho vezu */

 char KeyScan = 0;                       /* kd naposledy stisknut klvesy */

 FILE *MyFile;        /* ukazatel na idic strukturu souboru (viz STDIO.H) */
 int FErr;                           /* pznak chyby pi prci se souborem */

 int x, y;                                        /* pomocn promnn cyklu */


 SSFlag = 0;                         /* nuluj pznak poadavku na aktivaci */

 Rg.h.ah = 0x0F;
 int86(0x10, &Rg, &Rg);       /* INT 10h, Fn 0Fh - zjisti aktuln videomd */
 VideoMode = Rg.h.al;         /* a poet sloupc                            */
 NCol = Rg.h.ah;

 Rg.h.ah = 0x11;
 Rg.h.al = 0x30;
 Rg.h.dl = 24;
 int86 (0x10, &Rg, &Rg);    /* INT 10h, Fn 11h, SubFn 30h - zjisti aktuln */
 LRow = Rg.h.dl;            /* slo poslednho textovho dku             */

 VideoRAM = VideoMode == 7 ? 0xB000 : 0xB800;        /* nastav segment VRAM */

 SwapAttr(MyCurs.X, MyCurs.Y);                      /* zapni vlastn kurzor */
 while ((KeyScan != 0x1C) && (KeyScan != 1)) /* a do potvrzenjej pemisuj*/
  {
   KeyScan = bioskey(0) / 0xFF;
   SwapAttr(MyCurs.X, MyCurs.Y);
   switch (KeyScan)
      {
       case 0x48 : if(MyCurs.Y)  MyCurs.Y--;                  /* ipka nahoru */
                         else STBeep(30, 500); break;
       case 0x50 : if(MyCurs.Y < LRow) MyCurs.Y++;              /* ipka dolu */
                         else STBeep(30, 500); break;
       case 0x4D : if(MyCurs.X < NCol-1) MyCurs.X++;          /* ipka vpravo */
                         else STBeep(30, 500); break;
       case 0x4B : if(MyCurs.X) MyCurs.X--;                    /* ipka vlevo */
                         else STBeep(30, 500);
      }
   SwapAttr(MyCurs.X, MyCurs.Y);
  }
 if(KeyScan == 0x1C)                       /* je-li potvrzen lev horn roh */
  {
   KeyScan = 0;
   WinTop.X = MyCurs.X; WinTop.Y = MyCurs.Y;
   while ((KeyScan != 0x1C) && (KeyScan != 1))
      {                                         /* do potvrzen oznauj vez */
       KeyScan = bioskey(0) / 0xFF;
       switch (KeyScan)
        {
         case 0x48 : if(MyCurs.Y > WinTop.Y)                  /* ipka nahoru */
                               {
                                SwapLine(WinTop.X, MyCurs.X, MyCurs.Y);
                                MyCurs.Y--;
                               }
                           else STBeep(30, 500);
                           break;
         case 0x50 : if(MyCurs.Y < LRow)                        /* ipka dolu */
                               {
                                MyCurs.Y++;
                                SwapLine(WinTop.X, MyCurs.X, MyCurs.Y);
                               }
                           else STBeep(30, 500);
                           break;
         case 0x4D : if(MyCurs.X < NCol-1)                    /* ipka vpravo */
                               {
                                MyCurs.X++;
                                SwapColumn(MyCurs.X, WinTop.Y, MyCurs.Y);
                               }
                           else STBeep(30, 500);
                           break;
         case 0x4B : if(MyCurs.X > WinTop.X)                   /* ipka vlevo */
                               {
                                SwapColumn(MyCurs.X, WinTop.Y, MyCurs.Y);
                                MyCurs.X--;
                               }
                           else STBeep(30, 500);
        }
      }
      FErr = (MyFile = fopen("SCREEN.SAV", "ab")) == NULL;   /* otevi soubor */
      for (y = WinTop.Y; y <= MyCurs.Y; y++)             /* smyka po dkch */
       {
        for (x = WinTop.X; x <= MyCurs.X; x++)         /* smyka po sloupcch */
         {
            if(KeyScan == 0x1C && !FErr)   /* pokud potvrzeno a nedolo k chyb */
              fputc(peekb(VideoRAM, y*2*NCol + x*2), MyFile);     /* zapi znak */
            SwapAttr(x, y);                  /* vra atribut do pvodnho stavu */
         }
         if(KeyScan == 0x1C && !FErr)
             { fputc(0x0D, MyFile); fputc(0x0A, MyFile);} /* na konci dku CRLF*/
       }
      if (!FErr) fclose(MyFile);                             /* uzavi soubor */
  }
 else
  SwapAttr(MyCurs.X, MyCurs.Y);                  /* zrueno - zhasni kurzor */
}

void interrupt NewCritErr();
void interrupt NewBreak();

/* ------------------------------------------------------------------------ */
/* Funkce Resident je hlavn aktivan rutinou funknho jdra. Zajiuje   */
/* korektn pepnut proces a pmo vol vlastn jdro.                    */
/* ------------------------------------------------------------------------ */
void Resident()
{
 Run++;                                  /* nastav pznak vlastn aktivity */

 disable();
 IntSP = _SP;                    /* ulo stav zsobnku peruenho procesu */
 IntSS = _SS;
 _SP = Stack;                                    /* nastav vlastn zsobnk */
 _SS = MySS;
 enable();

 Rg.h.ah = 0x62;
 intdos(&Rg, &Rg);                /* DOS Fn 62h - zjisti adresu PSP         */
 IntPSP = Rg.x.bx;                /* uchovej adresu PSP peruenho procesu */

 Rg.h.ah = 0x50;
 Rg.x.bx = _psp;                          /* nastav vlastn PSP             */
 intdos(&Rg, &Rg);                        /* DOS Fn 50h - nastav adresu PSP */

 OldCritErr = getvect(0x24);      /* uchovej pvodn adresu obsluhy INT 24h */
 setvect(0x24, NewCritErr);       /* nastav vlastn obsluhu INT 24h         */

 OldBreak = getvect(0x1B);     /* uchovej pvodn adresu obsluhy Ctrl-Break */
 setvect(0x1B, NewBreak);      /* nastav vlastn obsluhu Ctrl-Break         */

 SaveScreen();                          /* voln vlastnho funknho jdra */

 setvect(0x1B, OldBreak);                /* vra pvodn obsluhu Ctrl-Break */
 setvect(0x24, OldCritErr);                 /* vra pvodn obsluhu INT 24h */

 Rg.h.ah = 0x50;
 Rg.x.bx = IntPSP;                        /* nastav pvodn PSP             */
 intdos(&Rg, &Rg);                        /* DOS Fn 50h - nastav adresu PSP */

 disable();
 _SP = IntSP;                                    /* nastav pvodn zsobnk */
 _SS = IntSS;
 enable();

 --Run;                                   /* nuluj pznak vlastn aktivity */
}

/* ------------------------------------------------------------------------ */
/* Na funkci NewTimer je pesmrovno peruen INT 08h od asovae.        */
/* Zajiuje periodickou kontrolu podmnek pro sputn a vlastn sputn   */
/* aktivan rutiny.                                                        */
/* ------------------------------------------------------------------------ */
void interrupt NewTimer(void)
{
 OldTimer();                                      /* voln pvodn obsluhy */
 if (SSFlag &&                        /* pokud byl poadavek na sputn,   */
       !*DosFlagPtr && !Run)            /* nen aktivn dos a nejsem aktivn, */
   Resident();                        /* pak spus aktivan funkci         */
}

/* ------------------------------------------------------------------------ */
/* Na funkci NewKeyboard je pesmrovno peruen INT 09h od klvesnice.   */
/* Zajiuje kontrolu stisku kombinace aktivanch klves a nastaven       */
/* pznaku poadavku na aktivaci.                                          */
/* ------------------------------------------------------------------------ */
void interrupt NewKeyboard(void)
{
 static char KbVal;

 if ( !Run &&                               /* pokud nejsem aktivn,        */
        inportb(0x60) == ScanCode &&          /* klvesa je moje aktivan    */
        (*Shifts & ShiftMask) == ShiftMask )  /* a jsou nastaveny peaovae */
  {
   SSFlag = 1;                              /* nastav poadavek na sputn */
   KbVal=inportb(0x61);
   outportb(0x61,KbVal|0x80);              /* potvrzen pevzet kdu znaku */
   outportb(0x61,KbVal);                   /* pro klvesnici                */
   outportb(0x20,0x20);       /* povolen pjmu dalho peruen pro 8259 */
   return;
  }
 OldKeyboard ();                  /* jinak volej pvodn obsluhu klvesnice */
}

/* ------------------------------------------------------------------------ */
/* Na funkci NewBreak je pesmrovn vektor INT 1Bh - klvesa Ctrl-Break po */
/* dobu prce TSR programu. Zajiuje indikaci Breaku a nahrazuje standard. */
/* obsluhu, kter ukonuje program.                                         */
/* ------------------------------------------------------------------------ */
void interrupt NewBreak(void)
{
 Break = 1;    /* nastav pznak Break (v tomto programu nen nikde pouit) */
}

/* ------------------------------------------------------------------------ */
/* Na funkci NewCritErr je pesmrovn vektor INT 24h - kritick chyba po   */
/* dobu prce TSR programu. Simuluje nvrat DOSu s chybou (stejn jako by   */
/* uivatel odpovdl na obvykl dotaz systmu "Fail".                      */
/* ------------------------------------------------------------------------ */
void interrupt NewCritErr( unsigned bp, unsigned di, unsigned si,
                                       unsigned ds, unsigned es, unsigned dx,
                                       unsigned cx, unsigned bx, unsigned ax,
                                       unsigned ip, unsigned cs, unsigned flgs)
{
 STBeep(500, 200);                     /* zvukov signl pi kritisk chyb */
 ax = (ax & 0xFF00) + 0x03;                     /* vra se do DOSu s chybou */
}

/* ------------------------------------------------------------------------ */
/* Na funkci NewDosSafe je pesmrovno peruen INT 28h , kter je gene-  */
/* rovno DOSem pi ekn na vstup z klvesnice. Zajiuje sputn akti-  */
/* van rutiny i kd je aktivn DOS prompt, nebo aplikace pouv funkce   */
/* DOSu pro vstup z klvesnice                                              */
/* ------------------------------------------------------------------------ */
void interrupt NewDosSafe(void)
{
 OldDosSafe();                                     /* volej pvodn obsluhu */
 if(SSFlag &&                           /* pokud je poadavek na sputn , */
      *DosFlagPtr && !Run)                /* je aktivn dos a nejsem aktivn, */
   Resident();                          /* pak spus aktivan funkci       */
}

/* ------------------------------------------------------------------------ */
/* Funkce Install provd vechn akce nutn pro sprvnou prci TSR programu */
/* po jeho umstn do pamti.                                              */
/* ------------------------------------------------------------------------ */
void Install(void)
{
 delay(1);                                /* kalibrace (prvn voln) delay */

 disable();
 MySS = _SS;                                      /* ulo segment zsobnku */
 Stack = _SP;                                        /* ulo stav zsobnku */
 enable();

 Rg.h.ah = 0x34;
 intdosx(&Rg, &Rg, &Seg);            /* DOS Fn 34h - adresa "DOS busy flag" */
 DosFlagPtr = MK_FP(Seg.es, Rg.x.bx);     /* uchovej adresu "DOS busy flag" */

 OldTimer = getvect(0x08);          /* ulo pvodn vektor obsluhy asovae */
 OldKeyboard = getvect(0x09);     /* ulo pvodn vektor obsluhy klvesnice */
 OldDosSafe = getvect(0x28);                 /* ulo pvodn vektor INT 28h */

 setvect(0x08, NewTimer);             /* nastav nov vektor obsluhy asovae*/
 setvect(0x09, NewKeyboard);        /* nastav nov vektor obsluhy klvesnice*/
 setvect(0x28, NewDosSafe);                   /* nastav nov vektor INT 28h */

 fputs("instalovn.\n", stdout);

 keep(0,_SS + (_SP>>4) + 1 - _psp);       /* ukoni se, ale zsta v pamti */
}

/* ------------------------------------------------------------------------ */
/* Hlavn program, v tto verzi pouze voln Install.                       */
/* ------------------------------------------------------------------------ */
void main(void)
{
 fputs("ScreenSaver-DEMO1 ", stdout);
 Install();
}