/* []-------------------------------------------------[] */
/* |                ScreenSaver-DEMO2                  | */
/* |       Pklad k serilu o TSR pro PC WORLD        | */
/* |  Peloit s Unsigned characters ON, TINI model !  | */
/* |             Aktivace Ctrl+Alt+F12.                | */
/* |  Umon oznait vez textov obrazovky a ulo   | */
/* |  jej do aktulnho adrese pod jmnem SCREEN.SAV | */
/* []-------------------------------------------------[] */

# include <dos.h>                   /* def. soubor pro pouit slueb DOSu  */
# include <stdio.h>                 /* def. soubor standardnch I/O funkc  */

# define ScanCode 0x58                      /* kd aktivan klvesy  (F12) */

# define AltScan 0x38                                    /* kd klvesy Alt */
# define CtrlScan 0x1D                               /* kd klvesy Control */
# define ExtScan 0xE0                  /* kd pznaku rozen klvesnice */

# define KbBuffLen 0x10               /* dlka vlastnho bufferu klvesnice */

extern unsigned _stklen  = 0x80;           /* nastaven velikosti zsobnku */
extern unsigned _heaplen = 0x480;     /* nastaven velikosti blzk hromady */

char Copyright[] = {"TSR ScreenSaver-DEMO2"};      /* identifikan etzec */

union REGS Rg;            /* struktura pro pedvn registrovch parametr */
struct SREGS Seg; /* struktura pro reg. parametry v segmentovch registrech */

unsigned IntSP,                 /* hodnota registru SP peruenho programu */
         IntSS,                 /* hodnota registru SS peruenho programu */
         IntPSP,                         /* adresa PSP peruenho programu */
         MySS,              /* registr SS rezidentu, uchovan pi instalaci */
         Stack;             /* registr SP rezidentu, uchovan pi instalaci */

unsigned MyTask;                /* identifikan slo procesu (na INT 2Fh) */

char KbBuff[KbBuffLen];                                /* buffer klvesnice */
char *KbTop = KbBuff;              /* vrchol bufferu - pt pjman znak */
char *KbBase = KbBuff;                /* dno bufferu - pt vybran znak */

char Scan = 0;                                          /* prv ten znak */
char PrevScan = 0;                                  /* naposledy ten znak */

char VideoPage,                                    /* aktuln videostrnka */
     VideoMode,                                       /* aktuln  videomd */
     NCol,                             /* poet textovch sloupc obrazovky */
     LRow;                    /* slo poslednho textovho dku obrazovky */

unsigned PageLen;                            /* dlka aktuln videostrnky */

char far *DosFlagPtr;                  /* ukazatel na pznak aktivity dosu */

unsigned VideoRAM;    /* aktuln segmentov adresa VideoRAM v text. reimu */

char Run    = 0;                               /* pznak vlastn aktivity  */
char SSFlag = 0;                           /* pznak poadavku na aktivaci */
char BiosDisk = 0;               /* pznak aktivity diskovch slueb BIOSu */
char Break  = 0;                                      /* pznak Ctrl-Break */
char ResOff = 0;                                      /* pznak deaktivace */

char Ctrl = 0;                                        /* pznak stavu Ctrl */
char Alt = 0;                                          /* pznak stavu Alt */
char ExtFlow = 0;      /* poet propoutnch pznak rozen klvesnice */

void interrupt (*OldTimer)(void);           /* pv. vektor obsluhy asovae */
void interrupt (*OldKeyboard)(void);      /* pv. vektor obsluhy klvesnice */
void interrupt (*OldIntKeyboard)(void);  /* vektor klvesnice ped aktivac */
void interrupt (*OldBiosDisk)(void);  /* pv. vektor diskovch slueb BIOSu */
void interrupt (*OldCritErr)(void);      /* pv. vektor obsluhy krit. chyby */
void interrupt (*OldDosSafe)(void);                  /* pv. vektor INT 28h */
void interrupt (*OldMultiplex)(void);                /* pv. vektor INT 2Fh */

/* ------------------------------------------------------------------------ */
/* Funkce STsetvect nahrazuje DOS Fn 25h pmm zpisem do pamti. Protoe  */
/* nepouv slueb DOSu, lze ji volat asynchronn.                         */
/* ------------------------------------------------------------------------ */
void STsetvect(int No, void interrupt (*fn) ( ))
{
 disable();                                              /* zkaz peruen */
 poke(0, No*4+2, FP_SEG(fn));             /* pepi segmentovou st adresy */
 poke(0, No*4, FP_OFF(fn));                 /* pepi ofsetovou st adresy */
 enable();                                            /* povolen peruen */
}

/* ------------------------------------------------------------------------ */
/* Funkce STgetvect nahrazuje DOS Fn 35h pmm tenm z pamti. Protoe    */
/* nepouv slueb DOS, lze ji volat asynchronn.                          */
/* ------------------------------------------------------------------------ */
void interrupt (*STgetvect(int no))()
{
 static void far *Res;

 disable();                                              /* zkaz peruen */
 Res = MK_FP(peek(0, (no<<2) + 2), peek(0, no<<2));        /* peti adresu */
 enable();                                            /* povolen peruen */
 return Res;
}

/* ------------------------------------------------------------------------ */
/* Funkce IncKbPtr inkrementuje ukazatel do kruhovho bufferu klvesnice.   */
/* ------------------------------------------------------------------------ */
void *IncKbPtr(char **Ptr)
{
 (*Ptr)++;                               /* inkrementuj ukazatel do bufferu */
 if(*Ptr == KbBuff + KbBuffLen) *Ptr = KbBuff;    /* peshl, pesu na dno */
 return Ptr;
}

/* ------------------------------------------------------------------------ */
/* Funkce GetScan vyzvedne kd klvesy z bufferu.                           */
/* ------------------------------------------------------------------------ */
char GetScan()
{
  char Scan;

 if (KbTop != KbBase)                          /* pokud buffer nen przdn */
  {
   Scan = *KbBase;                                      /* uchovej kd znaku*/
   IncKbPtr(&KbBase);              /* posu ukazatel dna na nsledujc kd */
   return Scan;                                           /* vra kd znaku */
  }
 return 0;                                       /* przdn buffer - vra 0 */
}

/* ------------------------------------------------------------------------ */
/* Funkce PutScan ulo kd prv stisknut klvesy do bufferu.             */
/* ------------------------------------------------------------------------ */
int PutScan(char Scan)
{
 static char *NextTop;

 NextTop = KbTop;
 IncKbPtr(&NextTop);

 if(NextTop != KbBase)                              /* pokud je jet msto */
  {
   *KbTop = Scan;                                         /* ulo kd znaku */
   KbTop = NextTop;                        /* posu ukazatel na dal voln */
   return 1;
  }
 return 0;
}

/* ------------------------------------------------------------------------ */
/* Funkce FlushKb vyprzdn buffer klvesnice                               */
/* ------------------------------------------------------------------------ */
void FlushKb()
{
 disable();                                              /* zkaz peruen */
 KbBase = KbBuff;                        /* ukazatel dna na zatek bufferu */
 KbTop = KbBuff;                     /* ukazatel vrcholu na zatek bufferu */
 enable();                                            /* povolen peruen */
}

void STBeep(unsigned Length, unsigned High)
{
 sound(High); delay(Length); nosound();
}

/* ------------------------------------------------------------------------ */
/* Funkce SwapAttr zinverzn znak v textovm reimu vmnou atribut barvy  */
/* textu (bity 0-2) a barvy pozad (bity 4-6).                              */
/* ------------------------------------------------------------------------ */
void SwapAttr(char X, char Y)
{
 char far *ScrAttr;

 ScrAttr = MK_FP(VideoRAM, VideoPage*PageLen + Y*2*NCol + X*2+1 );
 *ScrAttr = (((*ScrAttr >> 4) + (*ScrAttr << 4)) & 0x77) | (*ScrAttr & 0x88);
}

/* ------------------------------------------------------------------------ */
/* Funkce SwapLine "zinverzn" textov dek v zadanm rozsahu pomoc       */
/* voln funkce SwapAttr                                                   */
/* ------------------------------------------------------------------------ */
void SwapLine(char X1, char X2, char Y)
{
 for (; X1 <= X2; X1++) SwapAttr(X1, Y);
}

/* ------------------------------------------------------------------------ */
/* Funkce SwapColumn "zinverzn" textov sloupec v zadanm rozsahu pomoc   */
/* voln funkce SwapAttr                                                   */
/* ------------------------------------------------------------------------ */
void SwapColumn(char X, char Y1, char Y2)
{
 for (; Y1 <= Y2; Y1++) SwapAttr(X, Y1);
}

/* ------------------------------------------------------------------------ */
/* Funkce SaveScreen tvo vlasn funkn jdro programu. Je volna pi     */
/* splnn podmnek nutnch pro bezkolizn aktivaci TSR programu.           */
/* ------------------------------------------------------------------------ */
void SaveScreen(void)
{
 typedef struct
  { char X, Y; } POS;

 POS MyCurs = {0, 0};       /* souadnice aktuln polohy vlastnho kurzoru */
 POS WinTop = {0, 0};   /* souadnice levho hornho rohu oznaenho vezu */

 char KeyScan = 0;                       /* kd naposledy stisknut klvesy */

 FILE *MyFile;        /* ukazatel na idic strukturu souboru (viz STDIO.H) */
 int FErr;                           /* pznak chyby pi prci se souborem */

 int x, y;                                        /* pomocn promnn cyklu */
 unsigned p;             /* pomocn promnn pro vpoet dlky videostrnky */

 SSFlag = 0;                         /* nuluj pznak poadavku na aktivaci */

 Rg.h.ah = 0x0F;
 int86(0x10, &Rg, &Rg);       /* INT 10h, Fn 0Fh - zjisti aktuln videomd */
 VideoMode = Rg.h.al;         /* a poet sloupc                            */
 NCol = Rg.h.ah;
 VideoPage = Rg.h.bh;

 Rg.h.ah = 0x11;
 Rg.h.al = 0x30;
 Rg.h.dl = 24;
 int86 (0x10, &Rg, &Rg);    /* INT 10h, Fn 11h, SubFn 30h - zjisti aktuln */
 LRow = Rg.h.dl;            /* slo poslednho textovho dku             */

 VideoRAM = VideoMode == 7 ? 0xB000 : 0xB800;        /* nastav segment VRAM */

 PageLen = NCol * (LRow+1);     /* vpoet absolutn velikosti videostrnky */
 for(p = 4096; p<PageLen; p+=p*2);             /* zaokrouhli na mocninu 4KB */
 PageLen = p;

 SwapAttr(MyCurs.X, MyCurs.Y);                      /* zapni vlastn kurzor */
 while ((KeyScan != 0x1C) && (KeyScan != 1)) /* a do potvrzenjej pemisuj*/
  {
   while (!(KeyScan = GetScan()));
   SwapAttr(MyCurs.X, MyCurs.Y);
   switch (KeyScan)
	{
	 case 0x48 : if(MyCurs.Y)  MyCurs.Y--;                  /* ipka nahoru */
				 else STBeep(30, 500); break;
	 case 0x50 : if(MyCurs.Y < LRow) MyCurs.Y++;              /* ipka dolu */
				 else STBeep(30, 500); break;
	 case 0x4D : if(MyCurs.X < NCol-1) MyCurs.X++;          /* ipka vpravo */
				 else STBeep(30, 500); break;
	 case 0x4B : if(MyCurs.X) MyCurs.X--;                    /* ipka vlevo */
				 else STBeep(30, 500);
	}
   SwapAttr(MyCurs.X, MyCurs.Y);
  }
 if(KeyScan == 0x1C)                       /* je-li potvrzen lev horn roh */
  {
   KeyScan = 0;
   WinTop.X = MyCurs.X; WinTop.Y = MyCurs.Y;
   while ((KeyScan != 0x1C) && (KeyScan != 1))
	{                                         /* do potvrzen oznauj vez */
	 while (!(KeyScan = GetScan()));
	 switch (KeyScan)
	  {
	   case 0x48 : if(MyCurs.Y > WinTop.Y)                  /* ipka nahoru */
					 {
					  SwapLine(WinTop.X, MyCurs.X, MyCurs.Y);
					  MyCurs.Y--;
					 }
				   else STBeep(30, 500);
				   break;
	   case 0x50 : if(MyCurs.Y < LRow)                        /* ipka dolu */
					 {
					  MyCurs.Y++;
					  SwapLine(WinTop.X, MyCurs.X, MyCurs.Y);
					 }
				   else STBeep(30, 500);
				   break;
	   case 0x4D : if(MyCurs.X < NCol-1)                    /* ipka vpravo */
					 {
					  MyCurs.X++;
					  SwapColumn(MyCurs.X, WinTop.Y, MyCurs.Y);
					 }
				   else STBeep(30, 500);
				   break;
	   case 0x4B : if(MyCurs.X > WinTop.X)                   /* ipka vlevo */
					 {
					  SwapColumn(MyCurs.X, WinTop.Y, MyCurs.Y);
					  MyCurs.X--;
					 }
				   else STBeep(30, 500);
	  }
	}
	FErr = (MyFile = fopen("SCREEN.SAV", "ab")) == NULL;   /* otevi soubor */
	for (y = WinTop.Y; y <= MyCurs.Y; y++)             /* smyka po dkch */
	 {
	  for (x = WinTop.X; x <= MyCurs.X; x++)         /* smyka po sloupcch */
	   {
		if(KeyScan == 0x1C && !FErr)   /* pokud potvrzeno a nedolo k chyb */
		  fputc(peekb(VideoRAM, y*2*NCol + x*2), MyFile);     /* zapi znak */
		SwapAttr(x, y);                  /* vra atribut do pvodnho stavu */
	   }
	   if(KeyScan == 0x1C && !FErr)
		 { fputc(0x0D, MyFile); fputc(0x0A, MyFile);} /* na konci dku CRLF*/
	 }
	if (!FErr) fclose(MyFile);                             /* uzavi soubor */
  }
 else
  SwapAttr(MyCurs.X, MyCurs.Y);                  /* zrueno - zhasni kurzor */
}

void interrupt IntKeyboard(void);
void interrupt NewCritErr();

/* ------------------------------------------------------------------------ */
/* Funkce Resident je hlavn aktivan rutinou funknho jdra. Zajiuje   */
/* korektn pepnut proces a pmo vol vlastn jdro.                    */
/* ------------------------------------------------------------------------ */
void Resident()
{
 Run++;                                  /* nastav pznak vlastn aktivity */

 disable();
 IntSP = _SP;                    /* ulo stav zsobnku peruenho procesu */
 IntSS = _SS;
 _SP = Stack;                                    /* nastav vlastn zsobnk */
 _SS = MySS;
 enable();

 ExtFlow = Ctrl + Alt - 2;           /* poet pznak rozen klvesnice */

 FlushKb();                                  /* vyprzdni buffer klvesnice */
 OldIntKeyboard = STgetvect(0x9);     /* uchovej vektor peruenho procesu */
 STsetvect(0x9, IntKeyboard);          /* nastav vlastn obsluhu klvesnice */

 Rg.h.ah = 0x62;
 intdos(&Rg, &Rg);                /* DOS Fn 62h - zjisti adresu PSP         */
 IntPSP = Rg.x.bx;                /* uchovej adresu PSP peruenho procesu */

 Rg.h.ah = 0x50;
 Rg.x.bx = _psp;                          /* nastav vlastn PSP             */
 intdos(&Rg, &Rg);                        /* DOS Fn 50h - nastav adresu PSP */

 OldCritErr = getvect(0x24);      /* uchovej pvodn adresu obsluhy INT 24h */
 setvect(0x24, NewCritErr);       /* nastav vlastn obsluhu INT 24h         */

 SaveScreen();                          /* voln vlastnho funknho jdra */

 setvect(0x24, OldCritErr);                 /* vra pvodn obsluhu INT 24h */

 Rg.h.ah = 0x50;
 Rg.x.bx = IntPSP;                        /* nastav pvodn PSP             */
 intdos(&Rg, &Rg);                        /* DOS Fn 50h - nastav adresu PSP */

 STsetvect(0x9, OldIntKeyboard);                 /* vra obsluhu klvesnice */

 disable();
 _SP = IntSP;                                    /* nastav pvodn zsobnk */
 _SS = IntSS;
 enable();

 --Run;                                   /* nuluj pznak vlastn aktivity */
}

/* ------------------------------------------------------------------------ */
/* Na funkci NewTimer je pesmrovno peruen INT 08h od asovae.        */
/* Zajiuje periodickou kontrolu podmne pro sputn a vlastn sputn   */
/* aktivan rutiny.                                                        */
/* ------------------------------------------------------------------------ */
void interrupt NewTimer(void)
{
 OldTimer();                                      /* voln pvodn obsluhy */
 if (SSFlag &&                        /* pokud byl poadavek na sputn,   */
	 !*DosFlagPtr && !Run)            /* nen aktivn dos a nejsem aktivn, */
   Resident();                        /* pak spus aktivan funkci         */
}

/* ------------------------------------------------------------------------ */
/* Funkce AcceptKey zajiuje potvrzen pijatho znaku klvesnici.         */
/* ------------------------------------------------------------------------ */
void AcceptKey()
{
 static char KbVal;

 KbVal=inportb(0x61);
 outportb(0x61,KbVal|0x80);                /* potvrzen pevzet kdu znaku */
 outportb(0x61,KbVal);                     /* pro klvesnici                */
 outportb(0x20,0x20);         /* povolen pjmu dalho peruen pro 8259 */
 return;
}

/* ------------------------------------------------------------------------ */
/* Na funkci NewKeyboard je pesmrovno peruen INT 09h od klvesnice.   */
/* Zajiuje vlastn kontrolu stisku kombinace aktivanch klves           */
/* a nastaven pznaku poadavku na aktivaci.                              */
/* ------------------------------------------------------------------------ */
void interrupt NewKeyboard()
{
 if (!Run)
  {
   PrevScan = Scan;                            /* ulo kd posledn klvesy */
   Scan = inportb(0x60);                     /* peti kd aktuln klvesy */
   switch (Scan)
   {
															  /* stisk Ctrl */
	case CtrlScan        : Ctrl = PrevScan==ExtScan ? 2 : 1; /* 1 lev Ctrl */
						   break;                           /* 2 prav Ctrl */

															   /* stisk Alt */
	case AltScan         : Alt  = PrevScan==ExtScan ? 2 : 1;  /* 1 lev Alt */
						   break;                            /* 2 prav Alt */

	case CtrlScan | 0x80 : Ctrl = 0;  break;               /* uvolnn Ctrl */

	case AltScan | 0x80  : Alt  = 0;  break;                /* uvolnn Alt */

													   /* aktivan klvesa */
	case ScanCode        : if (Ctrl && Alt   /* pokud stisknuty peaovae */
								&& ! ResOff) /* a neprovd se deinstalace  */
						   {
							AcceptKey();           /* potvr pevzet znaku */
							SSFlag++;       /* nastav poadavek na aktivaci */
							return;
						   }
   }
 }
 OldKeyboard ();                                   /* volej pvodn obsluhu */
}

/* ------------------------------------------------------------------------ */
/* Funkce IntKeyboard tvo vlastn obsluhu klvesnice po dobu bhu rezi-   */
/* dentnho jdra. K pvodn obsluze propout pouze uvolnn pslunho   */
/* Ctrl a Alt, aby nedolo k jejich zablokovn pro BIOS                    */
/* ------------------------------------------------------------------------ */
void interrupt IntKeyboard(void)
{
 static char KbPort;

 KbPort = inportb(0x60);                              /* zjisti kd klvesy */
 if (Ctrl && KbPort == (CtrlScan | 0x80))
  { Ctrl = 0; OldIntKeyboard(); return;}     /* propus prvn uvolnn Ctrl */
 if (Alt  && KbPort == (AltScan | 0x80))
  { Alt = 0; OldIntKeyboard(); return;}       /* propus prvn uvolnn Alt */
 if (ExtFlow && KbPort == ExtScan)         /* propus odpovdajc poet    */
  { ExtFlow--; OldIntKeyboard(); return;}  /* pznak rozen klvesnice */
 if (KbPort < 0x80 && !PutScan(KbPort)) /* kd stisknut klvesy do bufferu */
   STBeep(10,500);                       /* pokud pln buffer, zvuk. signl */
 AcceptKey();                                      /* potvr pevzet znaku */
}

/* ------------------------------------------------------------------------ */
/* Funkce NewBiosDisk monitoruje aktivitu diskovch operac BIOSu.          */
/* ------------------------------------------------------------------------ */
void far NewBiosDisk(void)
{
 asm  mov BiosDisk, 1;                    /* nstav pznak aktivity INT 13h */
 asm  pushf;
 asm  call dword ptr CS:OldBiosDisk;               /* volej pvodn obsluhu */
 asm  mov BiosDisk, 0;                             /* nuluj pznak INT 13h */
 asm  retf 2;
}

/* ------------------------------------------------------------------------ */
/* Na funkci NewCritErr je pesmrovn vektor INT 24h - kritick chyba po   */
/* dobu prce TSR programu. Simuluje nvrat DOSu s chybou (stejn jako by   */
/* uivatel odpovdl na obvykl dotaz systmu "Fail".                      */
/* ------------------------------------------------------------------------ */
void interrupt NewCritErr( unsigned bp, unsigned di, unsigned si,
						   unsigned ds, unsigned es, unsigned dx,
						   unsigned cx, unsigned bx, unsigned ax,
						   unsigned ip, unsigned cs, unsigned flgs)
{
 STBeep(500, 200);                     /* zvukov signl pi kritisk chyb */
 ax = (ax & 0xFF00) + 0x03;                     /* vra se do DOSu s chybou */
}

/* ------------------------------------------------------------------------ */
/* Na funkci NewDosSafe je pesmrovno peruen INT 28h , kter je gene-  */
/* rovno DOSem pi ekn na vstup z klvesnice. Zajiuje sputn akti-  */
/* van rutiny i kd je aktivn DOS prompt, nebo aplikace pouv funkce   */
/* DOSu pro vstup z klvesnice                                              */
/* ------------------------------------------------------------------------ */
void interrupt NewDosSafe(void)
{
 OldDosSafe();                                     /* volej pvodn obsluhu */
 if(SSFlag &&                           /* pokud je poadavek na sputn , */
	*DosFlagPtr && !Run)                /* je aktivn dos a nejsem aktivn, */
   Resident();                          /* pak spus aktivan funkci       */
}

void interrupt NewMultiplex();

/* ------------------------------------------------------------------------ */
/* Funkce Terminate provede deinstalaci TSR programu (pokud je to mon).   */
/* ------------------------------------------------------------------------ */
char Terminate()
{
 if ((STgetvect(0x08)==NewTimer) &&   /* pokud nikdo neobsadil mnou pouit */
	 (STgetvect(0x09)==NewKeyboard) &&     /* vektory, mohu se odinstalovat */
	 (STgetvect(0x13)==
	  (void interrupt(*)())((unsigned long)NewBiosDisk+3)) &&
	 (STgetvect(0x28)==NewDosSafe) &&
	 (STgetvect(0x2F)==NewMultiplex))
	{
	 ResOff = 1;                              /* nastav pznak deinstalace */
	 STsetvect(0x08,OldTimer);              /* vra vechny pouit vektory */
	 STsetvect(0x09,OldKeyboard);           /* do pvodnho stavu           */
	 STsetvect(0x13,OldBiosDisk);
	 STsetvect(0x28,OldDosSafe);
	 STsetvect(0x2F,OldMultiplex);

	 Rg.h.ah = 0x49;
	 Seg.es = _psp;                    /* adresa vlastnho pamovho bloku */
	 intdosx(&Rg,&Rg,&Seg);              /* DOS Fn 49h - uvolni blok pamti */

	 return 0;
	}
 return 1;                               /* nelze odinstalovat - vra chybu */
}

/* ------------------------------------------------------------------------ */
/* Funkce NewMultiplex obsad vektor INT 2Fh (komunikace mezi procesy)      */
/* a pebr komunikaci procesu s slem MyTask.                            */
/* ------------------------------------------------------------------------ */
void interrupt NewMultiplex( unsigned bp, unsigned di, unsigned si,
							 unsigned ds, unsigned es, unsigned dx,
							 unsigned cx, unsigned bx, unsigned ax,
							 unsigned ip, unsigned cs, unsigned flgs)
{
 if ((ax & 0xFF00) == MyTask)         /* je poadovna komunikace se mnou ? */
  {
  switch (ax & 0x00FF)                             /* vymaskuj slo funkce */
   {
	case 0x00 : ax = ax | 0x00FF;      /* funkce 00h - kontrola ptomnosti */
				es = FP_SEG(Copyright);    /* pedej adresu identifikanho */
				bx = FP_OFF(Copyright);    /* etzce                       */
				break;
	case 0xC0 : if(ax = Terminate())            /* funkce C0h - deinstalace */
				  flgs = flgs | 0x0001;           /* pokud nelze, nastav CF */
   }
   }
 else                             /* vra registry a sko na pvodn vektor */
   asm {
		 pop bp
		 pop di
		 pop si
		 pop ds
		 pop es
		 pop dx
		 pop cx
		 pop bx
		 pop ax
		 jmp dword ptr CS:OldMultiplex
	   }
}

/* ------------------------------------------------------------------------ */
/* IdentStr je pomocn funkce pro porovnvn etzc na 'far' adresch.    */
/* ------------------------------------------------------------------------ */
int IdentStr(char far *Master, char far *Copy)
{
 while (*Master) if (*Master++ != *Copy++) return 0;
 return 1;
}

/* ------------------------------------------------------------------------ */
/* Funkce Install provd vechn akce nutn pro sprvnou prci TSR programu */
/* po jeho umstn do pamti.                                              */
/* ------------------------------------------------------------------------ */
int Install()
{
 delay(1);                                /* kalibrace (prvn voln) delay */
 MyTask = 0xFF00;                /* zani prohledvat sla procesu 'shora' */
 do
  {
   Rg.x.ax = MyTask;
   int86(0x2F,&Rg, &Rg);   /* dotaz na ptomnost procesu s slem MyTask */
   if (Rg.h.al == 0)       /* nen-li obsazen - instaluj s tmto slem   */
	{
	 disable();
	 MySS = _SS;                                   /* ulo segment zsobnku */
	 Stack = _SP;                                     /* ulo stav zsobnku */
	 enable();

	 Rg.h.ah = 0x34;
	 intdosx(&Rg, &Rg, &Seg);        /* DOS Fn 34h - adresa "DOS busy flag" */
	 DosFlagPtr = MK_FP(Seg.es, Rg.x.bx); /* uchovej adresu "DOS busy flag" */

	 OldTimer = STgetvect(0x08);    /* ulo pvodn vektor obsluhy asovae */
	 OldKeyboard = STgetvect(0x09);   /* ulo pv. vektor obskuhy klvesnice*/
	 OldBiosDisk = STgetvect(0x13);          /* olo pvodn vektor INT 13h */
	 OldDosSafe = STgetvect(0x28);           /* ulo pvodn vektor INT 28h */
	 OldMultiplex = STgetvect(0x2F);         /* ulo pvodn vektor INT 2Fh */

	 STsetvect(0x08, NewTimer);       /* nastav nov vektor obsluhy asovae*/
	 STsetvect(0x09, NewKeyboard);  /* nastav nov vektor obsluhy klvesnice*/
	 STsetvect(0x13,                          /* nastav nov vektor INT 13h */
	  (void interrupt(*)())((unsigned long)NewBiosDisk+3));
	 STsetvect(0x28, NewDosSafe);             /* nastav nov vektor INT 28h */
	 STsetvect(0x2F, NewMultiplex);           /* nastav nov vektor INT 2Fh */

	 fputs("instalovn.\n", stdout);

	 Rg.h.ah = 0x49;
	 Seg.es = peek(_psp, 0x2C);                 /* adresa Enviromentu z PSP */
	 intdosx(&Rg,&Rg,&Seg);              /* DOS Fn 49h - uvolni blok pamti */

	 keep(0,_SS + (_SP>>4) + 1 - _psp);   /* ukoni se, ale zsta v pamti */
	}
   MyTask = MyTask - 0x100;                          /* dal slo procesu */
  }
 while(MyTask > 0x7F00);       /* procesy pod 80h vyhrazeny intern pro DOS */
 fputs("nelze nainstalovat!", stdout);
 return 1;       /* nebylo nalezeno voln slo procesu, nelze nainstalovat */
}

/* ------------------------------------------------------------------------ */
/* Hlavn program zjist ptomnost sv kopie v pamti,a podle toho se bu  */
/* nainstaluje nebo ji pod o odinstalovn.                              */
/* ------------------------------------------------------------------------ */
int main(void)
{
 char TaskNum = 0xFF;

 fputs("ScreenSaver-DEMO2 ", stdout);

 while(TaskNum > 0x7F)            /* hledej svoji kopii v rozsahu 7Fh - FFh */
  {
   Rg.h.ah = TaskNum;
   Rg.h.al = 0;
   int86x(0x2F, &Rg, &Rg, &Seg);      /* dotaz na ptomnost procesu Taskum */
   if (Rg.h.al == 0xFF)              /* pokud ptomen, porovnej ID etzec */
	if(IdentStr(MK_FP(_DS, Copyright), MK_FP(Seg.es, Rg.x.bx)))
	 {                                                  /* etzec souhlas */
      Rg.h.ah = TaskNum;
      Rg.h.al = 0xC0;
      int86(0x2F, &Rg, &Rg);                  /* poadavek na odinstalovn */
      if (Rg.x.flags & 0x0001)
       { fputs("nelze odinstalovat!\n", stdout); return 3; }
      else
       { fputs("odinstalovn.\n", stdout); return 2; }
     }
   TaskNum--;                                        /* dal slo procesu */
  }
 return Install();                           /* kopie nenalezena - instaluj */
}