/*
TIM0TEST.C - Test vzorkovani a cteni systemoveho casovace c.0
(C) Ivan Dolezal  19. 8. 1994
*/
#pragma inline

#include <stdio.h>

#define  TICKS    (*(unsigned far *)0x46C)    /* ni slovo promnn BIOS
         - tae peruen IRQ 0 -> INT 08 od systmovho asovae .0 */

/* Funkce vzorkuje systmov asova .0 a vrac jeho aktuln stav */
unsigned gettimer(void)
{
asm {
  mov  al,0;      /* kd povelu pro vzorkovn systmovho asovae .0 */
  out  43h,al;    /* vysln povelu na dic port */
  jmp  $+2;
  jmp  $+2;       /* zpodn pro reakci obvodu pi vysok rychlosti CPU */
  in   al,40h;    /* ten niho bajtu asovae .0 */
  mov  ah,al;
  jmp  $+2;       /* zpodn pro reakci obvodu pi vysok rychlosti CPU */
  in   al,40h;    /* ten vyho bajtu asovae .0 */
  xchg ah,al;     /* prohozen bajt do sprvnho poad */
    }
return _AX;
}

int main(void)
   {
   unsigned t, t0, t1, ti1, ti2, ticks0;
   puts("\n--- TIM0TEST --- Test cteni systemoveho casovace kanal 0 ---\n");
   ti1 = ti2 = 0;                 /* znaka bezchybnho ten */
   ticks0 = TICKS + 1;            /* uloen pt hodnoty tae peruen */
   while ( TICKS != ticks0 );     /* ek na peruen od asovae .0 */
   t1 = t0 = gettimer();;         /* uchovn potenho stavu */
   ticks0++;                      /* pt hodnota tae peruen */
   while( t = gettimer(), TICKS != ticks0 )
      {                           /* te stav tae a ek na peruen */
      if (t > t0)                 /* nov hodnota > star pi dekrementaci ? */
         { ti1 = t0; ti2 = t; } /* uloen stav asovae ped a po podteen */
      t0 = t;                     /* aktualizace star hodnoty */
      }
   printf(   "Stav citace po zacatku intervalu preruseni  : %5u\n", t1 );
   if ( ti1 != ti2 )              /* jestlie dolo k podteen */
      printf("Chybny prechod nacitane hodnoty pres nulu   : %5u -> %5u\n\a",
             ti1, ti2 );
   printf(   "Stav citace pred koncem intervalu preruseni : %5u\n", t0 );
   return 0;
   }

