{POCITACOVY ZIVOT  3.dil
Rastuce objekty
Michal Danilak

VPIS PROGRAMU
}
program Bunkovy_rast;

uses
  Crt, Dos, Graph;
const
  max_vrch = 1025;
type
  vrchol_type = record
    x, y, uhol, rych : real;
    vek              : integer;
    stav             : shortint;
  end;
var
  vrchol : array[1..max_vrch] of vrchol_type;
  x0, y0, cas_del, cas_rast, cas,
  cas_list, typ_rastu, poc_vrch, volba : integer;
  uhol0, uh_vet, spomal                : real;

procedure Start_grafiky;
  var
    grDriver, grMod : integer;
begin
  grDriver:=Detect; InitGraph(grDriver,grMod,'');
  if GraphResult<>grOk then begin
    write('Chyba pri inicializacii grafiky');
    Halt(1);
  end;
end;

procedure Inicializacia_parametrov;
begin
  x0:=320; y0:=10; poc_vrch:=1;
  uhol0:=pi/2; uh_vet:=pi/6;
  cas_rast:=170; cas_list:=45; cas_del:=20;
  spomal:=0.8; typ_rastu:=1;
end;

procedure Rast_objektu;
  var
    por, prir, cis, st : word;

  procedure Stav_1;
  begin
    with vrchol[por] do begin
      inc(vek);
      x:=x+rych*cos(uhol);  {nova poloha vrcholu}
      y:=y+rych*sin(uhol);
      PutPixel(trunc(x),trunc(y),white);
      if vek>cas_del then begin  {vznikne novy vrchol}
        vek:=0; stav:=-stav; inc(prir);
        cis:=poc_vrch+prir;  {index noveho vrcholu}
        if cis>max_vrch then Halt(1);
        vrchol[cis].x:=x; vrchol[cis].y:=y;
        vrchol[cis].uhol:=stav*uh_vet+uhol;
        vrchol[cis].rych:=spomal*rych;
        vrchol[cis].vek:=0;
        vrchol[cis].stav:=typ_rastu;
          {parametre noveho vrcholu}
      end;
    end;
  end;

  procedure Stav_2;
  begin
    with vrchol[por] do begin
      if vek>cas_list then Exit; {ci uz je cas pre listy}
      inc(vek);
      x:=x+rych*cos(uhol);
      y:=y+rych*sin(uhol);
      PutPixel(trunc(x),trunc(y),white);
      if vek>cas_del then begin
        {vznik novych vrcholov na oboch stranach}
        inc(prir); cis:=poc_vrch+prir;
        if cis<max_vrch then begin
          vrchol[cis].x:=x; vrchol[cis].y:=y;
          vrchol[cis].uhol:=uh_vet+uhol;
          vrchol[cis].rych:=rych*(1-vek/cas_list);
          vrchol[cis].vek:=0; vrchol[cis].stav:=3;
          inc(prir); cis:=poc_vrch+prir;
        end;
        if cis<max_vrch then begin
          vrchol[cis].x:=x; vrchol[cis].y:=y;
          vrchol[cis].uhol:=uhol-uh_vet;
          vrchol[cis].rych:=rych*(1-vek/cas_list);
          vrchol[cis].vek:=0; vrchol[cis].stav:=3;
        end;
      end;
    end;
  end;

  procedure Stav_3;
  begin
    with vrchol[por] do begin {predlzenie vrcholu}
      inc(vek); if vek>(cas_list-cas_del) then Exit;
      x:=x+rych*cos(uhol); y:=y+rych*sin(uhol);
      PutPixel(trunc(x),trunc(y),white);
    end;
  end;

  procedure Stav_4;
  begin
    with vrchol[por] do begin  {predlzenie vrcholu}
      if vek>cas_list then Exit;
      inc(vek); x:=x+rych*cos(uhol); y:=y+rych*sin(uhol);
      PutPixel(trunc(x),trunc(y),white);
      if (vek>cas_del) and (vek mod 5 =0) then begin
        {vykreslenie kvetu}
        Circle(trunc(x),trunc(y),2);
      end;
    end;
  end;

begin
  Start_grafiky; poc_vrch:=1; cas:=0;
  with vrchol[1] do begin
    x:=x0; y:=y0; uhol:=uhol0; rych:=1;
    vek:=0; stav:=1;
  end;
  repeat
    prir:=0; inc(cas);
    for por:=1 to poc_vrch do begin
    {cinnost pre vsetky vrcholy}
      st:=abs(vrchol[por].stav);
      case st of
        1: Stav_1;
        2: Stav_2;
        3: Stav_3;
        4: Stav_4;
      end;
    end;
    poc_vrch:=poc_vrch+prir; {prirastok novych vrcholov}
  until (cas>cas_rast) or (KeyPressed);
  repeat until KeyPressed;
  CloseGraph;
end;

procedure Zmena_parametrov;
begin
  ClrScr; writeln('ZMENA PARAMETROV');
  write('doba rastu (',cas_rast,'): ');
  readln(cas_rast);
  write('uhol vetvenia (',uh_vet:5:3,'): ');
  readln(uh_vet);
  write('cas vetvenia (',cas_del,'): ');
  readln(cas_del);
  write('skratenie podvetiev (',spomal:5:3,'): ');
  readln(spomal);
  write('typ rastu 1-4 (',typ_rastu,'): ');
  readln(typ_rastu);
end;

begin
  Inicializacia_parametrov;
  repeat
    ClrScr; writeln('PONUKA CINNOSTI');
    writeln('1 - Rast objektu');
    writeln('2 - Zmena parametrov');
    writeln('3 - Koniec programu');
    write('VOLBA CINNOSTI: '); readln(volba);
    case volba of
      1: Rast_objektu;
      2: Zmena_parametrov;
    end;
  until volba=3;
end.